/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.catalog.internal.shp;

import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import org.geotools.data.shapefile.indexed.IndexedShapefileDataStoreFactory;

import net.refractions.udig.catalog.IService;
import net.refractions.udig.catalog.ServiceExtension;


/**
 * Provides ...TODO summary sentence
 * <p>
 * TODO Description
 * </p>
 * @author David Zwiers, Refractions Research
 * @since 0.6
 */
public class ShpServiceExtension implements ServiceExtension {

    private static IndexedShapefileDataStoreFactory shpDSFactory;
    /**
     * TODO summary sentence for getSHPDSFactory ...
     * 
     * @return x
     */
    public static IndexedShapefileDataStoreFactory getSHPDSFactory(){
        if(shpDSFactory == null)
            shpDSFactory = new IndexedShapefileDataStoreFactory();
        return shpDSFactory;
    }
    
    /**
     * TODO summary sentence for createService ...
     * 
     * @param id
     * @param params
     * @return x
     */
    public IService createService( URL id, Map<String,Serializable> params ) {
        if(params.containsKey(IndexedShapefileDataStoreFactory.URLP.key) ){
            // shapefile ...

            URL url = null;
            if(params.get(IndexedShapefileDataStoreFactory.URLP.key) instanceof URL){
                url = (URL)params.get(IndexedShapefileDataStoreFactory.URLP.key);
            }else{
                try {
                    url = (URL)IndexedShapefileDataStoreFactory.URLP.parse(params.get(IndexedShapefileDataStoreFactory.URLP.key).toString());
                    params.put(IndexedShapefileDataStoreFactory.URLP.key,url);
                } catch (Throwable e1) {
                    // log this?
                    e1.printStackTrace();
                    return null;
                }
            }
            String file=url.getFile();
            if( !(file.endsWith(".shp") || file.endsWith(".shx") ||file.endsWith(".qix")
            		|| file.endsWith(".dbf")))
            		return null;
                if(id == null){
                    return new ShpServiceImpl(url,params);
                }
                return new ShpServiceImpl(id,params);
        }
        return null;
    }

    /**
     * TODO summary sentence for createParams ...
     * 
     * @see net.refractions.udig.catalog.ServiceExtension#createParams(java.net.URL)
     * @param url
     * @return x
     */
    public Map<String,Serializable> createParams( URL url ) {
        if(getSHPDSFactory().canProcess(url)){
            // shapefile
            HashMap<String,Serializable> params = new HashMap<String,Serializable>();
            params.put(IndexedShapefileDataStoreFactory.URLP.key,url); 
            return params;
        }
        return null;
    }

}
