/*
 * uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This
 * library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 */
package net.refractions.udig.catalog.internal.ui;

import java.util.Iterator;

import net.refractions.udig.catalog.IGeoResource;
import net.refractions.udig.catalog.ui.FeatureSourceOp;
import net.refractions.udig.catalog.ui.FeatureStoreOp;
import net.refractions.udig.catalog.ui.IFeatureTypeOp;
import net.refractions.udig.catalog.ui.IOp;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.swt.widgets.Event;
import org.geotools.data.FeatureSource;
import org.geotools.data.FeatureStore;
import org.geotools.feature.FeatureType;

/**
 * Provides ...TODO summary sentence
 * <p>
 * TODO Description
 * </p>
 * <p>
 * Responsibilities:
 * <ul>
 * <li>
 * <li>
 * </ul>
 * </p>
 * <p>
 * Example Use:
 * 
 * <pre><code>
 * 
 *  FeatureTypeOpAction x = new FeatureTypeOpAction( ... );
 *  TODO code example
 *  
 * </code></pre>
 * 
 * </p>
 * 
 * @author jeichar
 * @since 0.3
 */
public class FeatureTypeOpAction extends Action implements ISelectionChangedListener {
//    private IExtension extension;
    private static final String TOOLTIP = "tooltip"; //$NON-NLS-1$
    private static final String ICON = "icon"; //$NON-NLS-1$
    private static final String NAME = "name"; //$NON-NLS-1$
    private static final String CLASS = "class"; //$NON-NLS-1$
    private IConfigurationElement configElem;
    private IStructuredSelection selection;
    private IExtension extention;

    /**
     * Construct <code>FeatureTypeOpAction</code>.
     * @param extention
     * @param element
     */
    public FeatureTypeOpAction( IExtension extention, IConfigurationElement element ) {
        this.extention = extention;
        this.configElem = element;
        setText(element.getAttribute(NAME));
        setImageDescriptor(Images.getDescriptor(element.getAttribute(ICON)));
        setToolTipText(element.getChildren(TOOLTIP)[0].getValue());
    }

    /**
     * TODO summary sentence for runWithEvent ...
     * 
     * @see org.eclipse.jface.action.Action#runWithEvent(org.eclipse.swt.widgets.Event)
     * @param event
     */
    public void runWithEvent( Event event ) {
        try {
            IOp op = (IOp) configElem.createExecutableExtension(CLASS);
            String name=configElem.getName();
            if (name.equals(FeatureSourceOp.EXTENSION)) {
                FeatureSourceOp fsOp = (FeatureSourceOp) op;
                for( Iterator iter = selection.iterator(); iter.hasNext(); ) {
                    IGeoResource resource = (IGeoResource) iter.next();
                    try {
                        fsOp.op(resource.resolve(FeatureSource.class,null));
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            else if (name.equals(FeatureStoreOp.EXTENSION)) {
                FeatureStoreOp fsOp = (FeatureStoreOp) op;
                for( Iterator iter = selection.iterator(); iter.hasNext(); ) {
                    IGeoResource resource = (IGeoResource) iter.next();
                    try {
                        fsOp.op(resource.resolve(FeatureStore.class,null));
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            else if (name.equals(IFeatureTypeOp.EXTENSION)) {
                IFeatureTypeOp fsOp = (IFeatureTypeOp) op;
                for( Iterator iter = selection.iterator(); iter.hasNext(); ) {
                    IGeoResource resource = (IGeoResource) iter.next();
                    try {
                        fsOp.op(resource.resolve(FeatureType.class,null));
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        } catch (CoreException e) {
            e.printStackTrace();
        }

    }
    
    /**
     * TODO summary sentence for selectionChanged ...
     * 
     * @see org.eclipse.jface.viewers.ISelectionChangedListener#selectionChanged(org.eclipse.jface.viewers.SelectionChangedEvent)
     * @param event
     */
    public void selectionChanged( SelectionChangedEvent event ) {
        this.selection = (IStructuredSelection) event.getSelection();
    }

    /**
     * @return Returns the extention.
     */
    public IExtension getExtention() {
        return extention;
    }
}
