/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.catalog.ui;

import org.geotools.data.FeatureSource;

/**
 * Provides support for FeatureStore processing.
 * 
 * @author jgarnett
 * @since 0.3
 */
public abstract class FeatureStoreOp extends Op {
    /** <code>EXTENSION</code> field */
    public static final String EXTENSION = "modifiableProcess"; //$NON-NLS-1$

    /**
     * Performs an opperation on schema producing a new Schema.
     * <p>
     * <b>Precondition:</b>
     * <ul>
     * <li>FeatureType is selected (or indicated) by the end user
     * <li>a user interface allow the end user to modify getParams is persented
     * <li>store is constructed for the selected FeatureType
     * <li>A DewfaultTransaction is started, and a set to the store.  
     * </ul>
     * </p>
     * <p>
     * <b>Postconditions</b>
     * <ul>
     * <li>If an exception occcurs the transaction will be rolled back
     * <li>If the op executes the transaction will be commited
     * </ul>
     * </p>
     * <p>
     * @param store FeatureStore ready for opperation
     * @throws Exception if opperation cannot be performed
     */ 
    public abstract void op( FeatureSource store ) throws Exception;
    
}
