/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.catalog.ui;

import org.geotools.feature.FeatureType;

/**
 * Provides support for FeatureType creation.
 * 
 * @author jgarnett
 * @since 0.3
 */
public interface IFeatureTypeOp extends IOp {
    
    /** <code>EXTENSION</code> field */
    public String EXTENSION = "create"; //$NON-NLS-1$

    /**
     * Performs an based on schema (such as creation).
     * <p>
     * <b>Precondition:</b>
     * <ul>
     * <li>schema is selected (or indicated) by the end user
     * <li>a user interface allow the end user to modify getParams is persented
     * </ul>
     * </p>
     * <p>
     * <b>Postconditions (depend on extention point):</b>
     * <ul>
     * <li>creation: User is asked which service to "save"
     * </ul>
     * </p>
     * @param schema
     * @return FeatureType based on origional schema
     * @throws Exception if opperation cannot be performed
     */
    public FeatureType op( FeatureType schema ) throws Exception;        
}
