/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.catalog.ui;

import java.util.Collections;
import java.util.Map;


/**
 * Op that operates at the level of a FeatureSource.
 * <p>
 * A slightly easier to use version of ServiceOp,
 * client code is responsible for doing any Transaction stuff they want.
 * </p>
 * @author jgarnett
 * @since 0.3
 */
public abstract class Op implements IOp {
    String id;
    String name;
    String description;
    /**
     * TODO summary sentence for getId ...
     * 
     * @see net.refractions.udig.catalog.ui.IOp#getId()
     * @return id of opperation
     */
    public String getId() {
        return id;
    }

    /**
     * TODO summary sentence for getName ...
     * 
     * @see net.refractions.udig.catalog.ui.IOp#getName()
     * @return name of opperation
     */
    public String getName() {
        return name;
    }

    /**
     * TODO summary sentence for getDescription ...
     * 
     * @see net.refractions.udig.catalog.ui.IOp#getDescription()
     * @return description of opperation
     */
    public String getDescription() {
        return description;
    }

    /**
     * Default parameters for your opperation.
     * <p>
     * Note there is idea of optional paramters, client code can do anything
     * but your keyset should remain the same (even if some values have been
     * set to null. It is not recomended to use null values (they don't
     * communicate anything to an end user) - try for real, honest, human readable
     * defaults.
     * </p>    
     * @see net.refractions.udig.catalog.ui.IOp#getParams()
     * @return parameter map, by default the EMPTY_MAP
     */
    public Map getParams() {
        return Collections.EMPTY_MAP;
    }

}
