/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.internal.ui;

import java.net.Authenticator;
import java.net.PasswordAuthentication;

import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.internal.Workbench;

public class UDIGAuthenticator extends Authenticator {
    private String username;
    private String password;

    protected PasswordAuthentication getPasswordAuthentication() {
        //TODO check if credentials have been previously entered and remembered
        Display.getDefault().syncExec(new Runnable(){
            public void run() {
                promptForPassword();
            }
        });
        
        if (username == null && password == null) {
            return null;
        }
        return new PasswordAuthentication(username, password.toCharArray());
    }
    
    protected void promptForPassword() {
        Shell shell = Workbench.getInstance().getActiveWorkbenchWindow().getShell();
        AuthenticationDialog dialog = new AuthenticationDialog(shell);
        int result = dialog.open();
        if (result == Window.CANCEL) {
            username = null;
            password = null;
            return;
        }
        username = dialog.getUsername();
        if (username == null) {
            username = ""; //$NON-NLS-1$
        }
        password = dialog.getPassword();
        if (password == null) {
            password = ""; //$NON-NLS-1$
        }
        if (dialog.shouldRemember()) {
            //TODO store credentials
        }
    }
}
