/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.internal.ui;

import java.util.ArrayList;
import java.util.List;

import net.refractions.udig.core.internal.ExtensionPointProcessor;
import net.refractions.udig.core.internal.ExtensionPointUtil;
import net.refractions.udig.ui.TransferFactory;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.swt.dnd.Transfer;

public class UDIGDropTargetProcessor {

	private static Processor processor;

	public static List<Transfer> getTransfers() {
		if (processor == null) {
			processor = new Processor();
			ExtensionPointUtil.process(UiPlugin.getDefault(),
					UiPlugin.DROP_TRANSFERS_ID, processor);
		}
		return processor.transfers;
	}

	static class Processor implements ExtensionPointProcessor {

		List<Transfer> transfers = new ArrayList<Transfer>();

		public void process(IExtension extension, IConfigurationElement element)
				throws Exception {
			Transfer[] tmp = ((TransferFactory) element.createExecutableExtension("class")).getTransfers(); //$NON-NLS-1$
			for (Transfer transfer : tmp) {
				transfers.add(transfer);  				
			}
		}
	}
}
