package net.refractions.udig.mapgraphic.internal;

import net.refractions.udig.project.ILayer;
import net.refractions.udig.project.internal.render.Renderer;
import net.refractions.udig.project.render.IRenderContext;
import net.refractions.udig.project.render.IRenderMetrics;
import net.refractions.udig.project.render.IRenderMetricsFactory;

public class MapGraphicRenderMetrics implements IRenderMetrics {

    IRenderContext context;
    private IRenderMetricsFactory factory;
    
    /**
     * Construct <code>MapGraphicRenderMetrics</code>.
     *
     */
    public MapGraphicRenderMetrics(IRenderContext context, IRenderMetricsFactory factory ) {
        this.factory=factory;
        this.context=context;
    }
    public Renderer createRenderer() {
        MapGraphicRenderer renderer = new MapGraphicRenderer();
        renderer.setContext(context);
        return renderer;
        
        //return new MapGraphicRenderer();
    }

    public IRenderContext getRenderContext() {
        return context;
    }

    /**
     * @see net.refractions.udig.project.render.IRenderMetrics#getRenderMetricsFactory()
     */
    public IRenderMetricsFactory getRenderMetricsFactory() {
        return factory;
    }
    
    public boolean canAddLayer( ILayer layer ) {
        return true;
    }
    public boolean canStyle( String SyleID, Object value ) {
        return true;
    }
} 