/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.printing.model;

import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.project.internal.Map;

/**
 * A generic implementation of a Decorator. It is associated with a Map and 
 * a Layer.
 * 
 * A Decorator is typically used to display something on a Map. This allows
 * it to removed from the Map and positioned around it on the Page. An example
 * of this is a scalebar, which needs to reference a map to draw its scale.
 * 
 * @author Richard Gould
 * @since 0.3
 * @model
 */
public interface DecoratorBox extends Box{ 
    /**
     * @return the Map associated with this DecoratorBox
     * @model many="false"
     */
    public Map getMap();
    
	/**
	 * Sets the value of the '{@link net.refractions.udig.printing.model.DecoratorBox#getMap <em>Map</em>}' reference.
	 * <!-- begin-user-doc -->
     * Sets this DecoratorBox's Map
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Map</em>' reference.
	 * @see #getMap()
	 * @generated
	 */
    void setMap(Map value);

    /**
     * @return the Layer associated with this DecoratorBox
     * @model
     */
    public Layer getLayer();

	/**
	 * Sets the value of the '{@link net.refractions.udig.printing.model.DecoratorBox#getLayer <em>Layer</em>}' reference.
	 * <!-- begin-user-doc -->
     * Sets this DecoratorBox's Layer
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Layer</em>' reference.
	 * @see #getLayer()
	 * @generated
	 */
    void setLayer(Layer value);

}
