/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.printing.model;

import net.refractions.udig.project.internal.Map;

/**
 * A MapBox represents a Map to be drawn.
 * 
 * @author Richard Gould
 * @since 0.3
 * @see Map
 * @model
 */
public interface MapBox extends Box{
    /**
     * @return This MapBox's map
     * @model many="false" containment="true"
     * @see Map
     */
    public Map getMap();
	/**
	 * Sets the value of the '{@link net.refractions.udig.printing.model.MapBox#getMap <em>Map</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * Sets the map associated with this MapBox
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Map</em>' containment reference.
	 * @see #getMap()
	 * @generated
	 */
    void setMap(Map value);

}
