/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.printing.ui.internal.editor.figures;

import java.awt.Graphics2D;

import net.refractions.udig.printing.model.Box;
import net.refractions.udig.ui.graphics.Graphics2DRenderer;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.geometry.Rectangle;

/**
 * Provides ...TODO summary sentence
 * <p>
 * TODO Description
 * </p><p>
 * Responsibilities:
 * <ul>
 * <li>
 * <li>
 * </ul>
 * </p><p>
 * Example Use:<pre><code>
 * NodeFigure x = new NodeFigure( ... );
 * TODO code example
 * </code></pre>
 * </p>
 * @author Richard Gould
 * @since 0.3
 */
public class LabelFigure extends Figure {
    private Box box;
    
    private RectangleFigure rectangleFigure;
    private Label label;

	private Graphics2DRenderer renderer = new Graphics2DRenderer();
    
    public LabelFigure() {
        this.rectangleFigure = new RectangleFigure();
        this.label = new Label();
        this.add(rectangleFigure);
        this.add(label);
    }
    
    public String getText() {
        return this.label.getText();
    }
    
    public Rectangle getTextBounds() {
        return this.label.getTextBounds();
    }
    
    public void setName(String name) {
        this.label.setText(name);
        this.repaint();
    }
    
    public void setBox( Box box ) {
        this.box = box;
        this.repaint();
    }
    public void setBounds(Rectangle rect) {
        super.setBounds(rect);
        this.rectangleFigure.setBounds(rect);
        this.label.setBounds(rect);
    }
    
    protected void paintFigure( Graphics graphics ) {
        super.paintFigure(graphics);
    }

	protected void paintClientArea(Graphics graphics) {
        graphics.translate(this.getLocation().x,this.getLocation().y);
	    renderer.prepareRendering(graphics); // prepares the Graphics2D renderer

	    // gets the Graphics2D context
	    final Graphics2D g2d = renderer.getGraphics2D();
        Job drawJob=new Job("Box drawing"){

            protected IStatus run( IProgressMonitor monitor ) {

                // does the Java 2D painting
                box.draw(g2d, monitor);
                return Status.OK_STATUS;
            }
            
        };
        drawJob.schedule();
        try {
			// FIXME FIXME FIXME FIXME
			drawJob.join();
			// now that we are done with Java 2D, renders Graphics2D operation
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	    // on the Draw2D graphics context
	    renderer.render(graphics);
	}
}
