/*
 * uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004,
 * Refractions Research Inc. This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; version 2.1 of the License. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 */
package net.refractions.udig.project.internal.command.navigation;

import net.refractions.udig.project.command.NavCommand;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.render.ViewportModel;

import org.eclipse.core.runtime.IProgressMonitor;

import com.vividsolutions.jts.geom.Envelope;

/**
 * TODO Purpose of net.refractions.udig.project.internal.command.navigation <p> </p>
 * @author   Jesse
 * @since   1.0.0
 */
public abstract class AbstractNavCommand implements NavCommand {

	private Envelope oldbbox = null;

	protected ViewportModel model = null;

	private Map map;

	/**
	 * @see net.refractions.udig.project.internal.command.UndoableCommand#rollback()
	 */
	public void rollback(IProgressMonitor monitor) throws Exception {
		model.zoomToBox(oldbbox);
	}

	/**
	 * @see net.refractions.udig.project.internal.command.MapCommand#run()
	 */
	public void run(IProgressMonitor monitor) throws Exception {
		oldbbox = model.getBounds();
		runImpl(monitor);
	}

	/**
	 * This where the actual implementation of subclasses should go.
	 * 
	 * @throws Exception
	 */
	protected abstract void runImpl(IProgressMonitor monitor) 
		throws Exception;

	/**
	 * @see net.refractions.udig.project.internal.command.navigation.NavCommand#setViewportModel(net.refractions.udig.project.ViewportModelControl)
	 */
	public void setViewportModel(ViewportModel model) {
		this.model = model;
	}

	/**
     * @see net.refractions.udig.project.command.MapCommand#setMap(net.refractions.udig.project.Map)
     * @uml.property   name="map"
     */
	public void setMap(Map map) {
		this.map = map;
	}

	/**
     * @see net.refractions.udig.project.command.MapCommand#getMap()
     * @uml.property   name="map"
     */
	public Map getMap() {
		return map;
	}

}
