/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.internal.commands;

import net.refractions.udig.project.command.MapCommand;
import net.refractions.udig.project.internal.Policy;
import net.refractions.udig.project.internal.command.navigation.AbstractNavCommand;

import org.eclipse.core.runtime.IProgressMonitor;

/**
 *  summary sentence.
 * <p>
 * Paragraph ...
 * </p><p>
 * Responsibilities:
 * <ul>
 * <li>
 * <li>
 * </ul>
 * </p><p>
 * Example:<pre><code>
 * StopRenderCommand x = new StopRenderCommand( ... );
 * TODO code example
 * </code></pre>
 * </p>
 * @author jgarnett
 * @since 0.6.0
 */
public class StopRenderCommand extends AbstractNavCommand{

    /*
     * @see net.refractions.udig.project.internal.command.navigation.AbstractNavCommand#runImpl()
     */
    protected void runImpl(IProgressMonitor monitor) throws Exception {
        getMap().getRenderManagerInternal().getRenderExecutor().stopRendering();
    }

    /*
     * @see net.refractions.udig.project.command.MapCommand#copy()
     */
    public MapCommand copy() {
        return new StopRenderCommand ();
    }

    /*
     * @see net.refractions.udig.project.command.MapCommand#getName()
     */
    public String getName() {
        return Policy.bind("StopRenderCommand.0"); //$NON-NLS-1$
    }

}
