/**
 * <copyright></copyright> $Id: AbstractContextImpl.java 15766 2005-09-20 20:55:15Z jeichar $
 */
package net.refractions.udig.project.internal.impl;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.io.IOException;
import java.util.List;

import net.refractions.udig.project.IEditManager;
import net.refractions.udig.project.ILayer;
import net.refractions.udig.project.IMap;
import net.refractions.udig.project.IProject;
import net.refractions.udig.project.internal.AbstractContext;
import net.refractions.udig.project.internal.EditManager;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.Project;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.render.RenderManager;
import net.refractions.udig.project.internal.render.ViewportModel;
import net.refractions.udig.project.render.IRenderManager;
import net.refractions.udig.project.render.IViewportModel;
import net.refractions.udig.project.render.displayAdapter.IMapDisplay;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.jface.action.IStatusLineManager;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.geotools.data.FeatureResults;
import org.geotools.data.FeatureSource;
import org.geotools.data.Query;
import org.geotools.geometry.JTS;
import org.geotools.geometry.JTS.ReferencedEnvelope;
import org.geotools.referencing.CRS;
import org.geotools.referencing.FactoryFinder;
import org.geotools.referencing.operation.GeneralMatrix;
import org.geotools.renderer.lite.Decimator;
import org.geotools.renderer.lite.LiteShape2;
import org.opengis.referencing.crs.CoordinateReferenceSystem;
import org.opengis.referencing.operation.MathTransform;
import org.opengis.referencing.operation.MathTransform2D;
import org.opengis.referencing.operation.MathTransformFactory;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.GeometryFactory;

/**
 * TODO Purpose of net.refractions.udig.project.internal.impl <p> </p>
 * @author   Jesse
 * @since   1.0.0
 * @generated
 */
public abstract class AbstractContextImpl extends EObjectImpl implements
		AbstractContext {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	/**
	 * The cached value of the '
	 * {@link #getRenderManagerInternal() <em>Render Manager Internal</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getRenderManagerInternal()
	 * @generated
	 * @ordered
	 */
	protected RenderManager renderManagerInternal = null;

	/**
	 * The cached value of the '{@link #getMapInternal() <em>Map Internal</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMapInternal()
	 * @generated
	 * @ordered
	 */
	protected Map mapInternal = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractContextImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ProjectPackage.eINSTANCE.getAbstractContext();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public IViewportModel getViewportModel() {
		return renderManagerInternal.getViewportModelInternal();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public IProject getProject() {
		return mapInternal.getProject();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public IEditManager getEditManager() {
		return mapInternal.getEditManager();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Coordinate getPixelSize() {
		return getViewportModel().getPixelSize();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public ViewportModel getViewportModelInternal() {
		return getMapInternal().getViewportModelInternal();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EditManager getEditManagerInternal() {
		return getMapInternal().getEditManagerInternal();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public RenderManager getRenderManagerInternal() {
		return renderManagerInternal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setRenderManagerInternal(RenderManager newRenderManagerInternal) {
		RenderManager oldRenderManagerInternal = renderManagerInternal;
		renderManagerInternal = newRenderManagerInternal;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.ABSTRACT_CONTEXT__RENDER_MANAGER_INTERNAL,
					oldRenderManagerInternal, renderManagerInternal));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public IMapDisplay getMapDisplay() {
		if (getRenderManager() == null)
			return null;
		return getRenderManager().getMapDisplay();
	}

	/**
	 * @see net.refractions.udig.project.IAbstractContext#getRenderManager()
	 */
	public IRenderManager getRenderManager() {
		return getRenderManagerInternal();
	}

	/**
	 * @see net.refractions.udig.project.IAbstractContext#getMap()
	 */
	public IMap getMap() {
		return getMapInternal();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Map getMapInternal() {
		return mapInternal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setMapInternal(Map newMapInternal) {
		Map oldMapInternal = mapInternal;
		mapInternal = newMapInternal;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.ABSTRACT_CONTEXT__MAP_INTERNAL,
					oldMapInternal, mapInternal));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Project getProjectInternal() {
		return getMapInternal().getProjectInternal();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public AffineTransform worldToScreenTransform() {
		return getViewportModel().worldToScreenTransform();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Point worldToPixel(Coordinate coord) {
		return getViewportModel().worldToPixel(coord);
	}

	public MathTransform2D worldToScreenMathTransform() {
		GeneralMatrix matrix = new GeneralMatrix(getViewportModelInternal()
				.worldToScreenTransform());
		try {
			return (MathTransform2D) FactoryFinder
					.getMathTransformFactory(null)
					.createAffineTransform(matrix);
		} catch (Exception e) {
			return null;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Coordinate pixelToWorld(int x, int y) {
		return getViewportModel().pixelToWorld(x, y);
	}

	public ReferencedEnvelope worldBounds(Rectangle rectangle) {
		Envelope start = new Envelope(rectangle.x, rectangle.x
				+ rectangle.width, rectangle.y, rectangle.y + rectangle.height);

		Envelope end = null;
		try {
			end = JTS.transform(start, worldToScreenMathTransform().inverse(),
					10);
		} catch (Exception e) {
			return null;
		}
		return new ReferencedEnvelope(end, getViewportModel().getCRS());
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Envelope getPixelBoundingBox(Point screenLocation) {
		return getBoundingBox(screenLocation, 1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public ReferencedEnvelope getBoundingBox(Point screenLocation,
			int scalefactor) {
		Coordinate center = pixelToWorld(screenLocation.x, screenLocation.y);
		Coordinate size = getPixelSize();
		double dw = size.x / 2 * scalefactor;
		double dh = size.y / 2 * scalefactor;
		Envelope e = new Envelope(center.x - dw, center.x + dw, center.y - dh,
				center.y + dh);
		return new ReferencedEnvelope(e, getCRS());
	}

	public IStatusLineManager getStatusBar() {
		IEditorSite site = getEditorSite();
		if (site == null)
			return null;
		return site.getActionBars().getStatusLineManager();
	}

	private IEditorSite getEditorSite() {
		IWorkbenchWindow window = getWindow();
		if (window == null)
			return null;
		IWorkbenchPage page = window.getActivePage();
		if (page == null)
			return null;
		IEditorPart part = page.getActiveEditor();
		if (part == null)
			return null;
		return (IEditorSite) part.getSite();
	}

	private IWorkbenchWindow getWindow() {
		IWorkbench bench = PlatformUI.getWorkbench();
		if (bench == null)
			return null;
		IWorkbenchWindow window = bench.getActiveWorkbenchWindow();
		if (window == null) {
			if (bench.getWorkbenchWindowCount() > 0)
				window = bench.getWorkbenchWindows()[0];
		}
		return window;
	}

	public void updateUI(Runnable runnable) {
		IWorkbench bench = PlatformUI.getWorkbench();
		Display display = null;
		if (bench != null)
			display = bench.getDisplay();

		if (display == null)
			display = Display.getDefault();

		display.asyncExec(runnable);
	}

	/**
	 * CoordinateReferenceSystem of the map.
	 * 
	 * @return getViewportModel().getCRS();
	 */
	public CoordinateReferenceSystem getCRS() {
		return getViewportModel().getCRS();
	}

	/**
	 * Transform the provided envelope to a java 2d shape (in screen coordiantes).
	 * 
	 * @param box
	 * @return
	 */
	public Shape toShape(ReferencedEnvelope envelope) {
		return toShape(new GeometryFactory().toGeometry(envelope), envelope
				.getCRS());
	}

	/**
	 * Transform the provided geometry to a java 2d shape (in screen coordiantes).
	 * 
	 * @param box
	 * @return Shape for geometry, or null if unavailable
	 */
	public Shape toShape(Geometry geometry, CoordinateReferenceSystem crs) {
		try {
			MathTransform transform = CRS.transform(crs, getCRS(), true);
			MathTransformFactory factory = FactoryFinder
					.getMathTransformFactory(null);
			MathTransform toScreen = factory
					.createAffineTransform(new GeneralMatrix(
							worldToScreenTransform()));
			transform = factory
					.createConcatenatedTransform(transform, toScreen);
			return new LiteShape2(geometry, transform,
					new Decimator(transform), false);
		} catch (Exception e) {
			return null;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public abstract Object clone();

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Query getQuery(ILayer layer, boolean selection) {
		return layer.getQuery(selection);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @throws IOException
	 * @generated NOT
	 */
	public FeatureResults getFeaturesInBbox(ILayer layer, Envelope bbox)
			throws IOException {
		return layer.getResource(FeatureSource.class, null).getFeatures(
				layer.createBBoxFilter(bbox, null));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.ABSTRACT_CONTEXT__RENDER_MANAGER_INTERNAL:
			return getRenderManagerInternal();
		case ProjectPackage.ABSTRACT_CONTEXT__MAP_INTERNAL:
			return getMapInternal();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.ABSTRACT_CONTEXT__RENDER_MANAGER_INTERNAL:
			setRenderManagerInternal((RenderManager) newValue);
			return;
		case ProjectPackage.ABSTRACT_CONTEXT__MAP_INTERNAL:
			setMapInternal((Map) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.ABSTRACT_CONTEXT__RENDER_MANAGER_INTERNAL:
			setRenderManagerInternal((RenderManager) null);
			return;
		case ProjectPackage.ABSTRACT_CONTEXT__MAP_INTERNAL:
			setMapInternal((Map) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.ABSTRACT_CONTEXT__RENDER_MANAGER_INTERNAL:
			return renderManagerInternal != null;
		case ProjectPackage.ABSTRACT_CONTEXT__MAP_INTERNAL:
			return mapInternal != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * @see net.refractions.udig.project.tool.ToolContext#getMapLayers()
	 */
	public List<ILayer> getMapLayers() {
		return getMap().getMapLayers();
	}

	public ILayer getSelectedLayer() {
		return getEditManager().getSelectedLayer();
	}

} // AbstractContextImpl
