/**
 * <copyright></copyright> $Id: ContextModelImpl.java 15766 2005-09-20 20:55:15Z jeichar $
 */
package net.refractions.udig.project.internal.impl;

import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import net.refractions.udig.project.internal.ContextModel;
import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.ProjectPlugin;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.geotools.data.FeatureSource;
import org.geotools.feature.FeatureType;
import org.geotools.filter.Filter;
import org.geotools.filter.FilterFactory;
import org.geotools.filter.GeometryFilter;
import org.geotools.filter.IllegalFilterException;

import com.vividsolutions.jts.geom.Envelope;

/**
 * TODO Purpose of net.refractions.udig.project.internal.impl <p> </p>
 * @author   Jesse
 * @since   1.0.0
 * @generated
 */
public class ContextModelImpl extends EObjectImpl implements ContextModel {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getLayers() <em>Layers</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getLayers()
	 * @generated
	 * @ordered
	 */
	protected EList layers = null;

	/**
	 * The cached value of the '{@link #getDeepAdapters() <em>Deep Adapters</em>}' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDeepAdapters()
	 * @generated
	 * @ordered
	 */
	protected EList deepAdapters = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	protected ContextModelImpl() {
		super();
		eAdapters().add(new AdapterImpl() {
			/**
			 * @see org.eclipse.emf.common.notify.impl.AdapterImpl#notifyChanged(org.eclipse.emf.common.notify.Notification)
			 */
			public void notifyChanged(Notification msg) {
				switch (msg.getFeatureID(ContextModel.class)) {
				case ProjectPackage.CONTEXT_MODEL__LAYERS: {
					if (getDeepAdapters().isEmpty())
						return;
					switch (msg.getEventType()) {
					case Notification.ADD: {
						((Layer) msg.getNewValue()).eAdapters().addAll(
								getDeepAdapters());
						break;
					}// case
					case Notification.ADD_MANY: {
						for (Iterator iter = ((List) msg.getNewValue())
								.iterator(); iter.hasNext();) {
							Layer element = (Layer) iter.next();
							element.eAdapters().addAll(getDeepAdapters());
						}
						break;
					}// case
					case Notification.REMOVE: {
						((Layer) msg.getOldValue()).eAdapters().removeAll(
								getDeepAdapters());
						break;
					}// case
					case Notification.REMOVE_MANY: {
						for (Iterator iter = ((List) msg.getOldValue())
								.iterator(); iter.hasNext();) {
							Layer element = (Layer) iter.next();
							element.eAdapters().removeAll(getDeepAdapters());
						}
						break;
					}// case
					}// switch
					break;
				}// case
				case ProjectPackage.CONTEXT_MODEL__DEEP_ADAPTERS: {
					switch (msg.getEventType()) {
					case Notification.ADD: {
						eAdapters().add(msg.getNewValue());
						for (Iterator iter = getLayers().iterator(); iter
								.hasNext();) {
							Layer layer = (Layer) iter.next();
							layer.eAdapters().add(msg.getNewValue());
						}
						break;
					}// case
					case Notification.ADD_MANY: {
						eAdapters().addAll((List) msg.getNewValue());
						for (Iterator iter = getLayers().iterator(); iter
								.hasNext();) {
							Layer layer = (Layer) iter.next();
							layer.eAdapters().addAll((List) msg.getNewValue());
						}
						break;
					}// case
					case Notification.REMOVE: {
						eAdapters().remove(msg.getOldValue());
						for (Iterator iter = getLayers().iterator(); iter
								.hasNext();) {
							Layer layer = (Layer) iter.next();
							layer.eAdapters().remove(msg.getOldValue());
						}
						break;
					}// case
					case Notification.REMOVE_MANY: {
						eAdapters().removeAll((List) msg.getOldValue());
						for (Iterator iter = getLayers().iterator(); iter
								.hasNext();) {
							Layer layer = (Layer) iter.next();
							layer.eAdapters().removeAll(
									(List) msg.getOldValue());
						}
						break;
					}// case
					}// switch
					break;
				}// case
				}// switch
			}
		});
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ProjectPackage.eINSTANCE.getContextModel();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List<Layer> getLayers() {
		if (layers == null) {
			layers = new EObjectContainmentWithInverseEList(Layer.class, this,
					ProjectPackage.CONTEXT_MODEL__LAYERS,
					ProjectPackage.LAYER__CONTEXT_MODEL);
		}
		return layers;
	}

	/**
	 * Typesafe Layer access as a workaround for EMF generation bug.
	 * 
	 * @return
	 */
	public List<Layer> layers() {
		return getLayers();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Map getMap() {
		if (eContainerFeatureID != ProjectPackage.CONTEXT_MODEL__MAP)
			return null;
		return (Map) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setMap(Map newMap) {
		if (newMap != eContainer
				|| (eContainerFeatureID != ProjectPackage.CONTEXT_MODEL__MAP && newMap != null)) {
			if (EcoreUtil.isAncestor(this, (EObject) newMap))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newMap != null)
				msgs = ((InternalEObject) newMap).eInverseAdd(this,
						ProjectPackage.MAP__CONTEXT_MODEL, Map.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newMap,
					ProjectPackage.CONTEXT_MODEL__MAP, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.CONTEXT_MODEL__MAP, newMap, newMap));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	public List<Adapter> getDeepAdapters() {
		if (deepAdapters == null) {
			deepAdapters = new EDataTypeUniqueEList(Adapter.class, this,
					ProjectPackage.CONTEXT_MODEL__DEEP_ADAPTERS);
		}
		return deepAdapters;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")
	public void lowerLayer(Layer layer) {
		int index = getLayers().indexOf(layer);
		if (index == 0)
			return;
		((EList) getLayers()).move(index--, index);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")
	public void raiseLayer(Layer layer) {
		int index = getLayers().indexOf(layer);
		if (index > getLayers().size() - 2)
			return;
		((EList) getLayers()).move(index++, index);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.CONTEXT_MODEL__LAYERS:
				return ((InternalEList) getLayers()).basicAdd(otherEnd, msgs);
			case ProjectPackage.CONTEXT_MODEL__MAP:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd,
						ProjectPackage.CONTEXT_MODEL__MAP, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.CONTEXT_MODEL__LAYERS:
				return ((InternalEList) getLayers())
						.basicRemove(otherEnd, msgs);
			case ProjectPackage.CONTEXT_MODEL__MAP:
				return eBasicSetContainer(null,
						ProjectPackage.CONTEXT_MODEL__MAP, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass,
						msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case ProjectPackage.CONTEXT_MODEL__MAP:
				return eContainer.eInverseRemove(this,
						ProjectPackage.MAP__CONTEXT_MODEL, Map.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE
				- eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.CONTEXT_MODEL__LAYERS:
			return getLayers();
		case ProjectPackage.CONTEXT_MODEL__MAP:
			return getMap();
		case ProjectPackage.CONTEXT_MODEL__DEEP_ADAPTERS:
			return getDeepAdapters();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.CONTEXT_MODEL__LAYERS:
			getLayers().clear();
			getLayers().addAll((Collection) newValue);
			return;
		case ProjectPackage.CONTEXT_MODEL__MAP:
			setMap((Map) newValue);
			return;
		case ProjectPackage.CONTEXT_MODEL__DEEP_ADAPTERS:
			getDeepAdapters().clear();
			getDeepAdapters().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.CONTEXT_MODEL__LAYERS:
			getLayers().clear();
			return;
		case ProjectPackage.CONTEXT_MODEL__MAP:
			setMap((Map) null);
			return;
		case ProjectPackage.CONTEXT_MODEL__DEEP_ADAPTERS:
			getDeepAdapters().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.CONTEXT_MODEL__LAYERS:
			return layers != null && !layers.isEmpty();
		case ProjectPackage.CONTEXT_MODEL__MAP:
			return getMap() != null;
		case ProjectPackage.CONTEXT_MODEL__DEEP_ADAPTERS:
			return deepAdapters != null && !deepAdapters.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (deepAdapters: "); //$NON-NLS-1$
		result.append(deepAdapters);
		result.append(')');
		return result.toString();
	}

	private GeometryFilter localize(FeatureType schema, GeometryFilter filter) {
		FilterFactory factory = FilterFactory.createFilterFactory();

		GeometryFilter copy;
		try {
			copy = factory.createGeometryFilter(filter.getFilterType());

			String geom = schema.getDefaultGeometry().getName();

			copy.addLeftGeometry(factory
					.createAttributeExpression(schema, geom));
			copy.addRightGeometry(filter.getRightGeometry());

			return copy;
		} catch (IllegalFilterException e) {
			return null;
		}
	}

	/*
	 * Constructs a filter for the provided layer, based on the GeometryFilter.
	 */
	private Filter target(Layer layer, Filter filter) {
		if (!layer.isSelectable()) {
			return Filter.NONE;
		}
		try {
			FeatureSource featureSource = layer.getResource(
					FeatureSource.class, null);
			if (featureSource == null) {
				return Filter.NONE;
			}

			FeatureType schema = layer.getSchema();

			Filter copy;
			if (filter instanceof GeometryFilter)
				copy = localize(schema, (GeometryFilter) filter);
			else
				copy = filter;

			if (copy == null) {
				return Filter.NONE;
			}
			return copy;
		} catch (IOException e) {
			ProjectPlugin.log(null, e);
			return Filter.NONE;
		}
	}

	public void select(Envelope boundingBox) {
		Layer selected = getMap().getEditManagerInternal().getSelectedLayer();
		LAYERS: for (Layer layer : getLayers()) {
			if (layer == selected) {
				try {
					Filter newFilter = layer
							.createBBoxFilter(boundingBox, null);
					if (newFilter == null)
						continue LAYERS;
					layer.setFilter(newFilter);
				} catch (IOException e) {
					ProjectPlugin.log(null, e);
				}
			} else {
				layer.setFilter(Filter.ALL);
			}
		}
		((MapImpl) getMap()).notifyBatchNotification(
				ProjectPackage.LAYER__FILTER, Notification.SET);
	}

	public void select(Envelope boundingBox, boolean and) {
		Layer selected = getMap().getEditManagerInternal().getSelectedLayer();
		LAYERS: for (Layer layer : getLayers()) {
			if (layer == selected) {
				Filter oldFilter = layer.getFilter();
				Filter newFilter = null;
				try {
					newFilter = layer.createBBoxFilter(boundingBox, null);
				} catch (IOException e) {
					ProjectPlugin.log(null, e);
				}
				if (newFilter == null)
					continue LAYERS;
				if (oldFilter == null || oldFilter == Filter.ALL
						|| oldFilter.equals(Filter.ALL)) {
					layer.setFilter(newFilter);
				} else if (!and) {
					layer.setFilter(oldFilter.and(newFilter));
				} else {
					layer.setFilter(oldFilter.or(newFilter));
				}
			} else {
				layer.setFilter(Filter.ALL);
			}

		}
	}

	/**
	 * @see net.refractions.udig.project.internal.ContextModel#select(Filter)
	 * @generated NOT
	 */
	public void select(Filter filter) {
		Layer selected = getMap().getEditManagerInternal().getSelectedLayer();
		LAYERS: for (Layer layer : getLayers()) {
			if (layer == selected) {
				layer.setFilter(target(layer, filter)); // replace
			} else {
				layer.setFilter(Filter.ALL);
			}
		}
	}

	/**
	 * @see net.refractions.udig.project.internal.ContextModel#select(Filter,
	 *      boolean)
	 * @generated NOT
	 */
	public void select(Filter filter, boolean and) {
		Layer selected = getMap().getEditManagerInternal().getSelectedLayer();
		LAYERS: for (Layer layer : getLayers()) {
			if (layer == selected) {
				Filter oldFilter = layer.getFilter();

				if (oldFilter == null || oldFilter == Filter.ALL
						|| oldFilter.equals(Filter.ALL)) {
					layer.setFilter(target(layer, filter));
				} else if (!and) {
					layer.setFilter(oldFilter.and(target(layer, filter)));
				} else {
					layer.setFilter(oldFilter.or(target(layer, filter)));
				}
			} else {
				layer.setFilter(Filter.ALL);
			}
		}
	}

	/**
	 * Turns off emf notification
	 * 
	 * @param notify
	 *            true if notifications should be used.
	 */
	public void setNotification(boolean notify) {
		if (notify)
			eFlags = eFlags | (EDELIVER);
		else
			eFlags = eFlags & (~EDELIVER);
	}
}
