/**
 * <copyright>
 * </copyright>
 *
 * $Id: LayerFactoryImpl.java 16045 2005-10-05 03:41:19Z jgarnett $
 */
package net.refractions.udig.project.internal.impl;

import java.awt.Color;
import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import net.refractions.udig.catalog.CatalogPlugin;
import net.refractions.udig.catalog.IGeoResource;
import net.refractions.udig.catalog.IGeoResourceInfo;
import net.refractions.udig.catalog.IService;
import net.refractions.udig.core.internal.ExtensionPointProcessor;
import net.refractions.udig.core.internal.ExtensionPointUtil;
import net.refractions.udig.project.StyleContent;
import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.project.internal.LayerFactory;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.ProjectFactory;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.ProjectPlugin;
import net.refractions.udig.ui.palette.ColourPaletteMasterList;
import net.refractions.udig.ui.palette.ColourScheme;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.geotools.data.DataStore;
import org.geotools.data.coverage.grid.GridCoverageExchange;
import org.geotools.data.ows.CRSEnvelope;
import org.geotools.data.wms.WMSUtils;
import org.geotools.data.wms.WebMapServer;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Layer Factory</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link net.refractions.udig.project.internal.impl.LayerFactoryImpl#getMap <em>Map</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class LayerFactoryImpl extends EObjectImpl implements LayerFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	protected int layerIndex = 0;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LayerFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ProjectPackage.eINSTANCE.getLayerFactory();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Map getMap() {
		if (eContainerFeatureID != ProjectPackage.LAYER_FACTORY__MAP)
			return null;
		return (Map) eContainer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMap(Map newMap) {
		if (newMap != eContainer
				|| (eContainerFeatureID != ProjectPackage.LAYER_FACTORY__MAP && newMap != null)) {
			if (EcoreUtil.isAncestor(this, (EObject) newMap))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newMap != null)
				msgs = ((InternalEObject) newMap).eInverseAdd(this,
						ProjectPackage.MAP__LAYER_FACTORY, Map.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newMap,
					ProjectPackage.LAYER_FACTORY__MAP, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER_FACTORY__MAP, newMap, newMap));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.LAYER_FACTORY__MAP:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd,
						ProjectPackage.LAYER_FACTORY__MAP, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.LAYER_FACTORY__MAP:
				return eBasicSetContainer(null,
						ProjectPackage.LAYER_FACTORY__MAP, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass,
						msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case ProjectPackage.LAYER_FACTORY__MAP:
				return eContainer.eInverseRemove(this,
						ProjectPackage.MAP__LAYER_FACTORY, Map.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE
				- eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.LAYER_FACTORY__MAP:
			return getMap();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.LAYER_FACTORY__MAP:
			setMap((Map) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.LAYER_FACTORY__MAP:
			setMap((Map) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.LAYER_FACTORY__MAP:
			return getMap() != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * Creates a list of {@linkplain Layer}objects from the provided selection.
	 * 
	 * @param selection A selection of CatalogEntries obtained from a {@linkplain CatalogTreeViewer}
	 *        object.
	 * @return a list of {@linkplain Layer}objects from the provided selection.
	 * @throws IOException 
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List<Layer> getLayers(List selection) throws IOException {
		List<Layer> layers = new LinkedList<Layer>();
		for (Iterator<Object> iter = selection.iterator(); iter.hasNext();) {
			Object obj = iter.next();
			if (obj instanceof IService) {
				layers.addAll(getLayers((IService) obj));
			} else if (obj instanceof IGeoResource) {
				IGeoResource entry = (IGeoResource) obj;
				Layer ref = createLayer(entry);

				if (ref != null)
					layers.add(ref);
			}
		}
		return layers;
	}

	public List<Layer> getLayers(IService service) throws IOException {
		Layer ref = null;
		List<Layer> layers = new LinkedList<Layer>();

		Iterator<? extends IGeoResource> rentryIter = service.members(null)
				.iterator();
		while (rentryIter.hasNext()) {
			IGeoResource entry = rentryIter.next();

			ref = createLayer(entry);

			if (ref != null)
				layers.add(ref);
		}
		return layers;
	}

	/**
	 * Creates a LayerRef for DataStores.
	 * 
	 * @param service the registry entry parent of the CatalogEntry that the Layer ref references.
	 * @param resource the CatalogEntry that the Ref refers to.
	 * @return a LayerRef for DataStores.
	 * @throws IOException 
	 */
	protected Layer createDataStoreLayer(IService service,
			IGeoResource resource, IProgressMonitor monitor) throws IOException {
		IGeoResourceInfo info = resource.getInfo(monitor);

		String label = info.getTitle(); // may be empty?
		if (label == null || label.trim().length() == 0) {
			label = info.getName(); // really should not be empty?
		}
		Layer layer = ProjectFactory.eINSTANCE.createLayer();
		if (layer == null) {
			return null;
		}
		layer.setName(label); // XXX: Is this a user provided label?
		layer.setID(resource.getIdentifier());
		return layer;
	}

	/**
	 * Creates a LayerRef for WMSs.
	 * 
	 * @param service the registry entry parent of the CatalogEntry that the Layer ref references.
	 * @param geoResource the CatalogEntry that the Ref refers to.
	 * @return a LayerRef for DataStores.
	 * @throws IOException
	 */
	protected Layer createWMSLayer(IService service, IGeoResource geoResource)
			throws IOException {

		org.geotools.data.ows.Layer wmslayer = null;

		IGeoResourceInfo info = geoResource.resolve(IGeoResourceInfo.class,
				null);
		String layerName = info.getName();
		if (layerName == null || layerName.length() == 0) {
			throw new IllegalArgumentException(
					"Cannot determine name of resource."); //$NON-NLS-1$
		}

		WebMapServer wms = service.resolve(WebMapServer.class, null);
		if (wms == null) {
			throw new IOException("Cannot communicate with Web Map Server."); //$NON-NLS-1$
		}
		org.geotools.data.ows.Layer[] layers = WMSUtils.getNamedLayers(wms
				.getCapabilities());
		for (org.geotools.data.ows.Layer layer : layers) {
			String targetName = layer.getName();
			if (targetName.equals(layerName)) {
				wmslayer = layer;
				break;
			}
		}

		if (wmslayer == null) {
			throw new IOException(
					"This resource (" + layerName + ") is not a part of the service. This is likely caused by inconsistent data returned by a search."); //$NON-NLS-1$//$NON-NLS-2$
		}

		//TODO look at the current viewport and figure out what crs it is in,
		// and figure out where the data is, and use that bounding box.

		CRSEnvelope latLonBBox = wmslayer.getLatLonBoundingBox();

		org.geotools.data.ows.Layer parent = wmslayer;
		while (latLonBBox == null && parent.getParent() != null) {
			latLonBBox = parent.getLatLonBoundingBox();
			parent = parent.getParent();
		}
		parent = null;

		if (latLonBBox == null) {
			// No latlonBoundingBoxes found at all, use the whole world.
			latLonBBox = new CRSEnvelope("EPSG:4326", -180, -90, 180, 90); //$NON-NLS-1$
			//TODO log warning
		}

		// TODO deal with metadata
		//LayerMetadata metadata = ProjectFactory.eINSTANCE.createLayerMetadata();
		//metadata.setName(wmslayer.getName());
		//metadata.setWmsName(entry.getInfo().getName());

		Layer layer = ProjectFactory.eINSTANCE.createLayer();

		String label = wmslayer.getTitle(); // may be empty

		if (label == null || label.trim().length() == 0) {
			label = wmslayer.getName(); // really is not allowed to be empty
		}
		layer.setName(label);

		//layer.setMetadata(metadata);
		//layer.setInfoable(wmslayer.isQueryable());
		layer.setID(geoResource.getIdentifier());

		return layer;
	}

	/**
	 * Returns a LayerFactory object
	 * 
	 * @return a LayerFactory object.
	 */
	public static LayerFactoryImpl create() {
		return new LayerFactoryImpl();
	}

	/**
	 * Creates a layer from a service and a resource. The layer is represented the data in resource.
	 * 
	 * May return null if it cannot resolve the service.
	 * 
	 * @param service
	 * @param resource
	 * @return
	 * @throws IOException 
	 */
	public synchronized Layer createLayer(IGeoResource resource)
			throws IOException {
		//this shouldn't be blocking because the resource should already have been added to the catalog.
		if (CatalogPlugin.getDefault().getLocalCatalog().find(
				resource.getIdentifier(), new NullProgressMonitor()).size() == 0) {
			CatalogPlugin.getDefault().getLocalCatalog().add(
					resource.service(null));
		}
		IService service = resource.service(null);

		if (service == null) {
			return null;
		}

		Layer layer = null;
		if (service.canResolve(DataStore.class)) {
			layer = createDataStoreLayer(service, resource, null);
		} else if (service.canResolve(WebMapServer.class)) {
			layer = createWMSLayer(service, resource);
		} else if (service.canResolve(GridCoverageExchange.class)) {
			layer = createGridCoverageLayer(service, resource);
		}
		// TODO: this check for a decorator service is not sufficient
		//else if (isDecoratorRe(service))
		else {
			layer = ProjectFactory.eINSTANCE.createLayer();

			layer.setID(resource.getIdentifier());
			// FIXME: here is an example of using info for fun and profit
			// IGeoResourceInfo info = resource.getInfo( null );
			// Envelope bounds = info.getBounds();
			// layer.setName( info.getTitle() );

		}

		if (layer == null) {
			throw new IOException(
					"Unable to create layer from resource '" + resource.getIdentifier() + "'"); //$NON-NLS-1$ //$NON-NLS-2$
		}

		//process the style content extension point to initially populate
		// the style blackboard with style info
		//TODO: the style objects need access to preference system
		final IGeoResource theResource = resource;
		final Layer theLayer = layer;

		ExtensionPointProcessor scp = new ExtensionPointProcessor() {
			public void process(IExtension extension,
					IConfigurationElement element) throws Exception {
				StyleContent styleContent = (StyleContent) element
						.createExecutableExtension("class"); //$NON-NLS-1$

				ColourScheme defaultScheme = getMap().getColourScheme();
				String letter = ColourPaletteMasterList.instance()
						.getColourLetterByLayerNumber(
								ColourPaletteMasterList.QUALITATIVE_TYPE,
								layerIndex);
				Color colour = defaultScheme.getColour(letter);
				theLayer.setColourScheme(defaultScheme);
				theLayer.setDefaultColor(letter);

				Object style = styleContent.createDefaultStyle(theResource,
						colour, null);

				if (style != null) {
					theLayer.getStyleBlackboard().put(styleContent.getId(),
							style);
				}
			}
		};
		ExtensionPointUtil.process(ProjectPlugin.getPlugin(),
				StyleContent.XPID, scp);
		layerIndex++;
		return layer;
	}

	/**
	 * TODO summary sentence for createGridCoverageLayer ...
	 * 
	 * @param service
	 * @param resource
	 * @return
	 * @throws IOException 
	 */
	protected Layer createGridCoverageLayer(IService service,
			IGeoResource resource) throws IOException {
		String name = resource.getInfo(null).getName();

		// TODO deal with metadata
		//LayerMetadata metadata = ProjectFactory.eINSTANCE.createLayerMetadata();
		//metadata.setName(name);

		Layer layer = ProjectFactory.eINSTANCE.createLayer();
		if (layer == null)
			return null;
		layer.setName(name);
		//layer.setMetadata(metadata);
		layer.setID(resource.getIdentifier());

		return layer;
	}

} //LayerFactoryImpl
