/**
 * <copyright></copyright> $Id: ProjectImpl.java 16728 2005-11-14 20:12:33Z rgould $
 */
package net.refractions.udig.project.internal.impl;

import java.io.File;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Stack;

import net.refractions.udig.project.command.Command;
import net.refractions.udig.project.internal.Policy;
import net.refractions.udig.project.internal.Project;
import net.refractions.udig.project.internal.ProjectElement;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.ProjectPlugin;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.URIConverter;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * TODO Purpose of net.refractions.udig.project.internal.impl <p> </p>
 * @author   Jesse
 * @since   1.0.0
 * @generated
 */
public class ProjectImpl extends EObjectImpl implements Project {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getName()
	 * @generated NOT
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = ""; //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getElementsInternal() <em>Elements Internal</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElementsInternal()
	 * @generated
	 * @ordered
	 */
	protected EList elementsInternal = null;

	private Adapter projectPersistenceListener = new AdapterImpl() {
		/**
		 * @see org.eclipse.emf.common.notify.impl.AdapterImpl#notifyChanged(org.eclipse.emf.common.notify.Notification)
		 */
		public void notifyChanged(Notification msg) {
			switch (msg.getFeatureID(Project.class)) {
			case ProjectPackage.PROJECT__ELEMENTS_INTERNAL:
			case ProjectPackage.PROJECT__NAME:
				if (ProjectImpl.this.eResource() != null)
					ProjectImpl.this.eResource().setModified(true);
			}
		}
	};

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	protected ProjectImpl() {
		super();
		eAdapters().add(projectPersistenceListener);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ProjectPackage.eINSTANCE.getProject();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.PROJECT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List getElementsInternal() {
		if (elementsInternal == null) {
			elementsInternal = new EObjectWithInverseResolvingEList(
					ProjectElement.class, this,
					ProjectPackage.PROJECT__ELEMENTS_INTERNAL,
					ProjectPackage.PROJECT_ELEMENT__PROJECT_INTERNAL) {

						@Override
						protected void didAdd(int index, Object newObject) {
							createResourceAndAddElement(ProjectImpl.this, (ProjectElement) newObject);
							super.didAdd(index, newObject);
						}

						@Override
						protected void didSet(int index, Object newObject, Object oldObject) {
							createResourceAndAddElement(ProjectImpl.this, (ProjectElement) newObject);
							super.didSet(index, newObject, oldObject);
						}
			};
		}
		return elementsInternal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List getElements(Class type) {
		List lists = new ArrayList();
		for (Iterator iter = getElementsInternal().iterator(); iter.hasNext();) {
			Object obj = iter.next();
			if (type.isAssignableFrom(obj.getClass()))
				lists.add(obj);
		}
		return lists;
	}
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		
		/*
		 * Reason for comment:
		 * During map creation, both this method and add seem to be called, but
		 * the resource should only ever be created once.
		 * 
		 * createResourceAndAddElement(this, (ProjectElement) otherEnd); 
		 */
		return eInverseAddGen(otherEnd, featureID, baseClass, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAddGen(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.PROJECT__ELEMENTS_INTERNAL:
				return ((InternalEList) getElementsInternal()).basicAdd(
						otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.PROJECT__ELEMENTS_INTERNAL:
				return ((InternalEList) getElementsInternal()).basicRemove(
						otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass,
						msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.PROJECT__NAME:
			return getName();
		case ProjectPackage.PROJECT__ELEMENTS_INTERNAL:
			return getElementsInternal();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.PROJECT__NAME:
			setName((String) newValue);
			return;
		case ProjectPackage.PROJECT__ELEMENTS_INTERNAL:
			getElementsInternal().clear();
			getElementsInternal().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.PROJECT__NAME:
			setName(NAME_EDEFAULT);
			return;
		case ProjectPackage.PROJECT__ELEMENTS_INTERNAL:
			getElementsInternal().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.PROJECT__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
					.equals(name);
		case ProjectPackage.PROJECT__ELEMENTS_INTERNAL:
			return elementsInternal != null && !elementsInternal.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: "); //$NON-NLS-1$
		result.append(name);
		result.append(')');
		return result.toString();
	}

	/**
	 * @see net.refractions.udig.project.IProject#getElements()
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List getElements() {
		return Collections.unmodifiableList(getElementsInternal());
	}

	Executor executor = new Executor(Policy.bind("ProjectImpl.executor")); //$NON-NLS-1$

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void send(Command command, boolean async) {
		executor.addCommand(command);
		executor.schedule();

		if (!async) {
			try {
				//wait
				while (true) {
					synchronized (command) {
						command.wait(100);
					}

					if (!executor.commands.contains(command))
						break;
				}
			} catch (InterruptedException e) {
				//TODO: log this
				e.printStackTrace();
			}
		}
	}

	public void sendASync(Command command) {
		send(command, true);
	}

	public void sendSync(Command command) {
		send(command, false);
	}

	/**
	 * Executes a command.
	 * @author jeichar
	 * @since 0.9.0
	 */
	public class Executor extends Job {

		private Stack<Command> commands = new Stack<Command>();

		/**
		 * Construct <code>Executor</code>.
		 *
		 * @param name the name of the job
		 */
		public Executor(String name) {
			super(name);
			setSystem(true);
			setPriority(LONG);
		}

		@Override
		protected IStatus run(IProgressMonitor monitor) {
			Command command;
			while (!commands.isEmpty()) {
				command = commands.peek();
				execute(command, monitor);

				synchronized (this) {
					commands.pop();
				}
				synchronized (command) {
					command.notifyAll();
				}

				break;
			}
			return Status.OK_STATUS;
		}

		/**
		 * Adds a command to the stack of commands that needs to be executed.
		 * 
		 * @param command
		 */
		public synchronized void addCommand(Command command) {
			commands.push(command);
		}

		/**
		 * Executes a command. Calls the Errorhandler if an exception is thrown.
		 * 
		 * @param command The command to execute
		 * @param monitor The progress monitor.
		 */
		public void execute(final Command command, IProgressMonitor monitor) {
			try {
				command.run(monitor);
			} catch (Exception e) {
				ProjectPlugin.log(null, e);
			}
		}

	}
	
	/**
	 * Creates a new Resource from map.  The new Resource will be in the same directory as the project's
	 * resource.  The Resource will start with map appended with a number that will make the name unique.
	 * The resource will end in .umap. 
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	private void createResourceAndAddElement(Project value, ProjectElement projectElement) {
		Resource projectResource = value.eResource();
		if (projectResource != null) {
			URI projectURI = projectResource.getURI();
			String mapPath = null;
			if (projectElement.eResource() != null) {
				mapPath = projectElement.eResource().getURI().toFileString();
				mapPath = mapPath.substring(0, mapPath
						.lastIndexOf(File.separatorChar));
			}

			String projectPath = projectURI.toFileString();
			projectPath = projectPath.substring(0, projectPath
					.lastIndexOf(File.separatorChar));
			while (projectPath.startsWith(File.separator + File.separator)) { //$NON-NLS-1$
				projectPath = projectPath.substring(1);
			}
			if (Platform.getOS().equals(Platform.OS_WIN32)
					&& projectPath.startsWith(File.separator)) { //$NON-NLS-1$
				projectPath = projectPath.substring(1);
			}

			// compare URI's to see if they are in the same archive
			if (!projectPath.equals(mapPath)) {
				Resource resource = null;

				URI uri = createNewResource(projectResource, projectPath);
				resource = projectResource.getResourceSet().createResource(uri);
				resource.getContents().add(projectElement);
			}
		}
	}

	
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	private URI createNewResource(Resource projectResource, String projectPath) {
		int i = 0;
		List<Resource> list = projectResource.getResourceSet().getResources();
		URIConverter uriConverter = projectResource.getResourceSet()
				.getURIConverter();
		URI uri = null;
		boolean found = false;
		do {
			found = false;
			i++;
			for (Resource resource2 : list) {
				//TODO Add file extension name to ProjectElement
				String tempPath = "file://" + projectPath + File.separator + "map" + i + ".umap"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				uri = URI.createURI(tempPath);
				URI normalizedURI = uriConverter.normalize(uri);
				if (uriConverter.normalize(resource2.getURI()).equals(
						normalizedURI)) {
					found = true;
					break;
				}
			}
			if (!found) {
				File file = new File(uri.toFileString());
				if (file.exists())
					found = true;
			}
		} while (found);
		return uri;
	}
	
} // ProjectImpl
