/**
 * <copyright></copyright> $Id: ProjectRegistryImpl.java 15766 2005-09-20 20:55:15Z jeichar $
 */
package net.refractions.udig.project.internal.impl;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import net.refractions.udig.project.IProject;
import net.refractions.udig.project.internal.Policy;
import net.refractions.udig.project.internal.Project;
import net.refractions.udig.project.internal.ProjectFactory;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.ProjectPlugin;
import net.refractions.udig.project.internal.ProjectRegistry;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.xmi.FeatureNotFoundException;
import org.eclipse.emf.ecore.xmi.XMIException;
import org.eclipse.swt.widgets.Display;

/**
 * TODO Purpose of net.refractions.udig.project.internal.impl <p> </p>
 * @author   Jesse
 * @since   1.0.0
 * @generated
 */
public class ProjectRegistryImpl extends EObjectImpl implements ProjectRegistry {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getProjects() <em>Projects</em>}' reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getProjects()
	 * @generated
	 * @ordered
	 */
	protected EList projects = null;

	/**
	 * The cached value of the '{@link #getCurrentProject() <em>Current Project</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getCurrentProject()
	 * @generated
	 * @ordered
	 */
	protected Project currentProject = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ProjectRegistryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ProjectPackage.eINSTANCE.getProjectRegistry();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List<Project> getProjects() {
		if (projects == null) {
			projects = new EObjectResolvingEList(Project.class, this,
					ProjectPackage.PROJECT_REGISTRY__PROJECTS);
		}
		return projects;
	}

	/**
	 * @see net.refractions.udig.project.internal.ProjectRegistry#getDefaultProject()
	 */
	public Project getDefaultProject() {
		String projectName = Policy.bind("ProjectRegistry.defaultName"); //$NON-NLS-1$
		String path = new File(Platform.getLocation().toString()
				+ File.separatorChar + projectName).getAbsolutePath();
		currentProject = getProject(path);
		return currentProject;
	}

	/**
	 * @see net.refractions.udig.project.internal.ProjectRegistry#getCurrentProject()
	 * @uml.property   name="currentProject"
	 */
	public Project getCurrentProject() {
		Project p = getCurrentProjectGen();
		if (p == null && getProjects().size() > 0)
			p = getProjects().get(0);
		return p;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Project getCurrentProjectGen() {
		if (currentProject != null && currentProject.eIsProxy()) {
			Project oldCurrentProject = currentProject;
			currentProject = (Project) eResolveProxy((InternalEObject) currentProject);
			if (currentProject != oldCurrentProject) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							ProjectPackage.PROJECT_REGISTRY__CURRENT_PROJECT,
							oldCurrentProject, currentProject));
			}
		}
		return currentProject;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Project basicGetCurrentProject() {
		return currentProject;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setCurrentProject(Project newCurrentProject) {
		Project oldCurrentProject = currentProject;
		currentProject = newCurrentProject;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.PROJECT_REGISTRY__CURRENT_PROJECT,
					oldCurrentProject, currentProject));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Project getProject(URI uri) {
		// There is a sporatic bug here. Remove this try/catch when it is fixed.
		try {
			if (findProject(uri) != null)
				return findProject(uri);

			URI resourceURI = URI.createURI(uri.toString()); //$NON-NLS-1$ //$NON-NLS-2$
			final ProjectRegistry registry = ProjectPlugin.getPlugin()
					.getProjectRegistry();
			Resource resource = registry.eResource().getResourceSet()
					.createResource(resourceURI);
			try {
				resource.load(null);
			} catch (IOException e1) {
				// resource doesn't exist. That is ok.
			}
			Project tmpProject;
			if (resource.getContents().isEmpty()) {
				tmpProject = createProject(uri, resource);
			} else {
				tmpProject = (Project) resource.getContents().get(0);
			}

			final Project newProject = tmpProject;

			Display.getDefault().syncExec(new Runnable() {

				public void run() {
					try {
						setCurrentProject(newProject);
						registry.getProjects().add(newProject);
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			});

			return newProject;
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
			// System.err.println("GetProject URI: " +uri);
		}
		return null; // remove this too
	}

	/**
	 * TODO summary sentence for findProject ...
	 * 
	 * @param uri
	 * @return
	 */
	private Project findProject(URI uri) {
		for (Iterator iter = getProjects().iterator(); iter.hasNext();) {
			Project project = (Project) iter.next();
			if (project.eResource().getURI().equals(uri))
				return project;
		}
		return null;
	}

	/**
	 * TODO summary sentence for createProject ...
	 * 
	 * @return
	 */
	private Project createProject(URI uri, Resource resource) {
		Project tmpProject = ProjectFactory.eINSTANCE.createProject();
		String path = uri.toFileString();
		int start = path.indexOf(File.separator) != -1 ? path
				.lastIndexOf(File.separator) : 0;
		int end = path.indexOf('.') != -1 ? path.lastIndexOf('.') : path
				.length() - 1;
		tmpProject.setName(path.substring(start + 1, end));
		resource.getContents().add(tmpProject);
		resource.setModified(true);

		return tmpProject;
	}

	public Project getProject(String projectPath) {
		// HACK
		if (!projectPath.startsWith("file://")) { //$NON-NLS-1$
			int index = 0;
			for (int i = 0; i < projectPath.length(); i++) {
				if (projectPath.charAt(i) == File.separatorChar)
					index++;
				else
					break;
			}
			projectPath = "file://" + projectPath.substring(index); //$NON-NLS-1$
		}
		// DONE HACK
		final String path = projectPath + "/project.uprj"; //$NON-NLS-1$
		final URI uri = URI.createURI(path);
		Project project = getProject(uri);
		return project;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.PROJECT_REGISTRY__CURRENT_PROJECT:
			if (resolve)
				return getCurrentProject();
			return basicGetCurrentProject();
		case ProjectPackage.PROJECT_REGISTRY__PROJECTS:
			return getProjects();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.PROJECT_REGISTRY__CURRENT_PROJECT:
			setCurrentProject((Project) newValue);
			return;
		case ProjectPackage.PROJECT_REGISTRY__PROJECTS:
			getProjects().clear();
			getProjects().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.PROJECT_REGISTRY__CURRENT_PROJECT:
			setCurrentProject((Project) null);
			return;
		case ProjectPackage.PROJECT_REGISTRY__PROJECTS:
			getProjects().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.PROJECT_REGISTRY__CURRENT_PROJECT:
			return currentProject != null;
		case ProjectPackage.PROJECT_REGISTRY__PROJECTS:
			return projects != null && !projects.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * @see net.refractions.udig.IProjectRegistry#getDefaultIProject()
	 */
	public IProject getDefaultIProject() {
		return getDefaultProject();
	}

	/**
	 * @see net.refractions.udig.IProjectRegistry#getCurrentIProject()
	 */
	public IProject getCurrentIProject() {
		return getCurrentProject();
	}

	/**
	 * @see net.refractions.udig.IProjectRegistry#setICurrentProject(net.refractions.udig.IProject)
	 */
	public void setICurrentProject(IProject value) {
		setCurrentProject((Project) value);
	}

	/**
	 * @see net.refractions.udig.IProjectRegistry#getIProject(java.lang.String)
	 */
	public IProject getIProject(String projectPath) {
		return getProject(projectPath);
	}

	/**
	 * @see net.refractions.udig.IProjectRegistry#getIProjects()
	 */
	public List getIProjects() {
		return getProjects();
	}

	private static ResourceSetImpl resourceSet;

	/**
	 * Loads the project registry.
	 * 
	 * @return the loaded project registry.
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public static ProjectRegistry load() {
		ProjectRegistry projectRegistry = null;
		try {
			IPath registrypath = ProjectPlugin.getPlugin().getStateLocation()
					.append("ProjectRegistry"); //$NON-NLS-1$
			URI uri = URI.createURI("file://" + registrypath.toOSString()); //$NON-NLS-1$
			// Load the resource through the editing domain.
			//
			resourceSet = new ResourceSetImpl();
			Resource resource;
			if (registrypath.toFile().exists()) {
				resource = resourceSet.getResource(uri, true);
				resourceSet.eSetDeliver(false);
				projectRegistry = (ProjectRegistry) resource.getContents().get(
						0);
				if (projectRegistry == null) {
					projectRegistry = ProjectFactory.eINSTANCE
							.createProjectRegistry();
					resource.getContents().add(projectRegistry);
				}
			} else {
				resource = resourceSet.createResource(uri);
				if (resource == null)
					throw new Exception(
							"Unable to load or create ProjectRegistry resource"); //$NON-NLS-1$

				projectRegistry = ProjectFactory.eINSTANCE
						.createProjectRegistry();
				resource.getContents().add(projectRegistry);
			}
		} catch (Exception exception) {
			ProjectPlugin.INSTANCE.log(exception);
		}
		if (projectRegistry == null)
			ProjectPlugin.log("Error getting project from resource"); //$NON-NLS-1$
		else {
			final ProjectRegistry registry = projectRegistry;
			projectRegistry.eAdapters().add(new AdapterImpl() {
				/**
				 * @see org.eclipse.emf.common.notify.impl.AdapterImpl#notifyChanged(org.eclipse.emf.common.notify.Notification)
				 */
				public void notifyChanged(Notification msg) {
					if (msg.getFeatureID(ProjectRegistry.class) == ProjectPackage.PROJECT_REGISTRY__PROJECTS) {
						registry.eResource().setModified(true);
					}
				}
			});
		}
		//        validateProjects(projectRegistry);
		resourceSet.eSetDeliver(false);
		return projectRegistry;
	}

	private static void validateProjects(ProjectRegistry registry2) {
		List<Project> danglingProjects = new ArrayList<Project>();
		for (Iterator iter = registry2.getProjects().iterator(); iter.hasNext();) {
			Project project = (Project) iter.next();
			if (project.eIsProxy()) {
				danglingProjects.add(project);
			}
		}
		List<Project> resurrectedProjects = new ArrayList<Project>();
		List<Resource.Diagnostic> problems = new ArrayList<Resource.Diagnostic>();
		for (Iterator iter = resourceSet.getResources().iterator(); iter
				.hasNext();) {
			Resource resource = (Resource) iter.next();
			problems.addAll(resource.getErrors());
			for (Iterator iterator2 = problems.iterator(); iterator2.hasNext();) {
				Resource.Diagnostic problem = (Resource.Diagnostic) iterator2
						.next();
				EObject object = null;
				if (problem instanceof FeatureNotFoundException)
					object = ((FeatureNotFoundException) problem).getObject();

				if (object instanceof Project || object == null)
					continue;
				while (object.eContainer() != null
						&& !(object instanceof Project))
					object = object.eContainer();

				if (object instanceof Project)
					resurrectedProjects.add((Project) object);
			}

			problems.addAll(resource.getWarnings());
			for (Iterator iterator = problems.iterator(); iterator.hasNext();) {
				Resource.Diagnostic element = (Resource.Diagnostic) iterator
						.next();
				if (element instanceof XMIException) {
					String trace = element.getMessage() + "\n"; //$NON-NLS-1$
					StackTraceElement[] stElems = ((XMIException) element)
							.getStackTrace();
					for (int i = 0; i < stElems.length; i++) {
						StackTraceElement elem = stElems[i];
						trace += "\t" + elem.getClassName() + "." + elem.getMethodName(); //$NON-NLS-1$ //$NON-NLS-2$
						trace += elem.isNativeMethod() ? "\n" : "(): line " //$NON-NLS-1$ //$NON-NLS-2$
								+ elem.getLineNumber() + "\n"; //$NON-NLS-1$
					}
					ProjectPlugin
							.getPlugin()
							.log(
									"Error loading Project. Stack Trace follows:\n" + trace); //$NON-NLS-1$
				} else
					ProjectPlugin.getPlugin().log(
							"Error loading Project:\n" + element.getMessage()); //$NON-NLS-1$

			}

		}
		registry2.getProjects().removeAll(danglingProjects);
		registry2.getProjects().addAll(resurrectedProjects);
	}

} // ProjectRegistryImpl
