/**
 * <copyright>
 * </copyright>
 *
 * $Id: ProjectItemProvider.java 15318 2005-08-12 02:21:36Z jeichar $
 */
package net.refractions.udig.project.internal.provider;

import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import net.refractions.udig.project.internal.Project;
import net.refractions.udig.project.internal.ProjectPackage;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link net.refractions.udig.project.internal.Project} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ProjectItemProvider extends ItemProviderAdapter
        implements
            IEditingDomainItemProvider,
            IStructuredItemContentProvider,
            ITreeItemContentProvider,
            IItemLabelProvider,
            IItemPropertySource {
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$
    private ChildFetcher childFetcher;

    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ProjectItemProvider( AdapterFactory adapterFactory ) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public List getPropertyDescriptors( Object object ) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addNamePropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    static class ChildFetcher extends Job {

        private ProjectItemProvider provider;
        public ChildFetcher() {
            super("Fetcher"); //$NON-NLS-1$
            setSystem(true);
            setPriority(Job.DECORATE);
        }

        ChildFetcher( ProjectItemProvider provider ) {
            this();
            this.provider = provider;
        }

        protected Collection getChildren() {
            return provider.getChildrenInternal(parent);
        }

        Collection children = null;
        Object parent;
        public boolean newRequest = false;
        @Override
        protected IStatus run( IProgressMonitor monitor ) {
            newRequest = false;
            try {
                children = getChildren();
            } catch (Exception e) {
                return Status.OK_STATUS;
            }
            if (!newRequest)
                notifyChanged();
            return Status.OK_STATUS;
        }

        protected void notifyChanged() {
            provider.notifyChanged(new ENotificationImpl((InternalEObject) parent,
                    Notification.SET, ProjectPackage.PROJECT__ELEMENTS_INTERNAL, null, null));
        }

    };

    Collection getChildrenInternal( Object object ) {
        return super.getChildren(object);
    }
    Collection lastChildren;
    @SuppressWarnings("unchecked")//$NON-NLS-1$
    @Override
    public Collection getChildren( Object object ) {
        if (childFetcher == null) {
            childFetcher = new ChildFetcher(this);
        }

        if (childFetcher.children != null) {
            lastChildren = childFetcher.children;
            childFetcher.children = null;
            return lastChildren;
        }

        childFetcher.parent = object;
        childFetcher.newRequest = true;
        childFetcher.schedule();

        if( lastChildren!=null ){
            return lastChildren;
        }
        
        Set set = new HashSet();
        set.add(Policy.bind("ProjectItemProvider.loading")); //$NON-NLS-1$
        return set;
    }

    /**
     * This adds a property descriptor for the Name feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addNamePropertyDescriptor( Object object ) {
        itemPropertyDescriptors
                .add(createItemPropertyDescriptor(
                        ((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
                        getResourceLocator(),
                        getString("_UI_Project_name_feature"), //$NON-NLS-1$
                        getString(
                                "_UI_PropertyDescriptor_description", "_UI_Project_name_feature", "_UI_Project_type"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
                        ProjectPackage.eINSTANCE.getProject_Name(), true,
                        ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * 
     * <!-- end-user-doc -->
     * @generated
     */
    public Collection getChildrenFeatures( Object object ) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(ProjectPackage.eINSTANCE.getProject_ElementsInternal());
        }
        return childrenFeatures;
    }

    /**
     * This returns Project.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Object getImage( Object object ) {
        return getResourceLocator().getImage("full/obj16/Project"); //$NON-NLS-1$
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public String getText( Object object ) {
        String label = ((Project) object).getName();
        return label == null || label.length() == 0 ? getString("_UI_Project_type") : //$NON-NLS-1$
                label; //$NON-NLS-1$ //$NON-NLS-2$
    }

    /**
     * @see org.eclipse.emf.edit.provider.ITreeItemContentProvider#hasChildren(java.lang.Object)
     */
    public boolean hasChildren( Object object ) {
        return true;
    }

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void notifyChanged( Notification notification ) {
        updateChildren(notification);

        switch( notification.getFeatureID(Project.class) ) {
        case ProjectPackage.PROJECT__NAME:
            fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(),
                    false, true));
            return;
        case ProjectPackage.PROJECT__ELEMENTS_INTERNAL:
            fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(),
                    true, false));
            return;
        }
        super.notifyChanged(notification);
    }

    /**
     * Return the resource locator for this item provider's resources.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ResourceLocator getResourceLocator() {
        return ProjectEditPlugin.INSTANCE;
    }

}
