/*
 * uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004,
 * Refractions Research Inc. This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; version 2.1 of the License. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 */
package net.refractions.udig.project.internal.render;

import java.util.Collection;
import java.util.List;

import net.refractions.udig.project.ILayer;
import net.refractions.udig.project.internal.Layer;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;

/**
 * TODO Purpose of net.refractions.udig.project.internal.render <p> </p>
 * @author   Jesse
 * @since   1.0.0
 * @model
 */
public interface RendererCreator extends EObject{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	/**
	 * Returns the value of the '<em><b>Toolkit</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Toolkit</em>' attribute isn't clear, there really should be
	 * more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Toolkit</em>' attribute.
	 * @see net.refractions.udig.project.internal.render.RenderPackage#getRendererCreator_Toolkit()
	 * @model transient="true" resolveProxies="false"
	 */
	RenderContext getContext();

    /**
     * Sets the value of the '{@link net.refractions.udig.project.internal.render.RendererCreator#getContext <em>Context</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Context</em>' reference.
     * @see #getContext()
     * @generated
     */
	void setContext(RenderContext value);

	/**
	 * Creates a Renderer which can render the provided layer
	 * 
	 * @param context A context object with a layer to be rendered. The layer will be used to
	 *        determine which renderer will be created
	 * @return a Renderer which can render the provided layer null if the layer type is not known
	 *         (for example a decorator with an unknown renderer)
	 * @model  resolveProxies="false"
	 */
	public Renderer getRenderer(RenderContext context);

	/**
	 * @return List <RenderContext>all the RenderContexts required for rendering all the layers in
	 *         the ContextModel.
	 * @model  resolveProxies="false"
	 */
	public RenderContext getRenderContext(Layer layer);

	/**
	 * Updates the state of the renderer configuration.
	 */
	void changed(Notification msg);

	/**
	 * Locates the selection layer for layer or returns null;
	 * 
	 * @return the selection layer for layer or returns null;
	 */
	public SelectionLayer findSelectionLayer(ILayer targetLayer);

	/**
	 * @return The list of layers that the RendererCreator is responsible for creating renderers
	 * @model type='net.refractions.udig.project.internal.Layer' resolveProxies='false'
	 */
	List<Layer> getLayers();

	/**
	 * Returns the current configuration of Contexts objects.
	 * 
	 * @return the current configuration of Contexts objects
	 */
	Collection<RenderContext> getConfiguration();

}
