/**
 * <copyright></copyright> $Id$
 */
package net.refractions.udig.project.internal.render.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import net.refractions.udig.catalog.IGeoResource;
import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.render.CompositeRenderContext;
import net.refractions.udig.project.internal.render.RenderContext;
import net.refractions.udig.project.internal.render.RenderManager;
import net.refractions.udig.project.internal.render.RenderPackage;
import net.refractions.udig.project.render.IRenderContext;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EObjectEList;
import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * TODO Purpose of net.refractions.udig.project.internal.render.impl <p> </p>
 * @author   Jesse
 * @since   1.0.0
 * @generated
 */
public class CompositeRenderContextImpl extends RenderContextImpl implements
		CompositeRenderContext {
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

    /**
     * The cached value of the '{@link #getContextsInternal() <em>Contexts Internal</em>}' reference list.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getContextsInternal()
     * @generated
     * @ordered
     */
	protected EList contextsInternal = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	protected CompositeRenderContextImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	protected EClass eStaticClass() {
        return RenderPackage.eINSTANCE.getCompositeRenderContext();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List<RenderContext> getContextsInternal() {
        if (contextsInternal == null) {
            contextsInternal = new EObjectEList(RenderContext.class, this, RenderPackage.COMPOSITE_RENDER_CONTEXT__CONTEXTS_INTERNAL);
        }
        return contextsInternal;
    }

	/**
	 * @see net.refractions.udig.project.internal.render.impl.RenderContextImpl#isVisible()
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public boolean isVisible() {
		if (getLayer() != null && getLayer().isVisible())
			return true;
		for (Iterator iter = getContexts().iterator(); iter.hasNext();) {
			IRenderContext context = (IRenderContext) iter.next();
			if (context == this)
				continue;
			if (context.isVisible())
				return true;
		}
		return false;
	}

	/**
	 * @see net.refractions.udig.project.internal.render.impl.RenderContextImpl#clone()
	 */
	public Object clone() {
		return EcoreUtil.copy(this);
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__RENDER_MANAGER_INTERNAL:
                return getRenderManagerInternal();
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__MAP_INTERNAL:
                return getMapInternal();
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__IMAGE:
                return getImage();
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__ZORDER:
                return new Integer(getZorder());
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__VISIBLE:
                return isVisible() ? Boolean.TRUE : Boolean.FALSE;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__LAYER_INTERNAL:
                return getLayerInternal();
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__GEO_RESOURCE_INTERNAL:
                return getGeoResourceInternal();
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__CONTEXTS_INTERNAL:
                return getContextsInternal();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__RENDER_MANAGER_INTERNAL:
                setRenderManagerInternal((RenderManager)newValue);
                return;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__MAP_INTERNAL:
                setMapInternal((Map)newValue);
                return;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__LAYER_INTERNAL:
                setLayerInternal((Layer)newValue);
                return;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__GEO_RESOURCE_INTERNAL:
                setGeoResourceInternal((IGeoResource)newValue);
                return;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__CONTEXTS_INTERNAL:
                getContextsInternal().clear();
                getContextsInternal().addAll((Collection)newValue);
                return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__RENDER_MANAGER_INTERNAL:
                setRenderManagerInternal((RenderManager)null);
                return;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__MAP_INTERNAL:
                setMapInternal((Map)null);
                return;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__LAYER_INTERNAL:
                setLayerInternal((Layer)null);
                return;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__GEO_RESOURCE_INTERNAL:
                setGeoResourceInternal(GEO_RESOURCE_INTERNAL_EDEFAULT);
                return;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__CONTEXTS_INTERNAL:
                getContextsInternal().clear();
                return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__RENDER_MANAGER_INTERNAL:
                return renderManagerInternal != null;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__MAP_INTERNAL:
                return mapInternal != null;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__IMAGE:
                return IMAGE_EDEFAULT == null ? image != null : !IMAGE_EDEFAULT.equals(image);
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__ZORDER:
                return getZorder() != ZORDER_EDEFAULT;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__VISIBLE:
                return isVisible() != VISIBLE_EDEFAULT;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__LAYER_INTERNAL:
                return layerInternal != null;
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__GEO_RESOURCE_INTERNAL:
                return GEO_RESOURCE_INTERNAL_EDEFAULT == null ? geoResourceInternal != null : !GEO_RESOURCE_INTERNAL_EDEFAULT.equals(geoResourceInternal);
            case RenderPackage.COMPOSITE_RENDER_CONTEXT__CONTEXTS_INTERNAL:
                return contextsInternal != null && !contextsInternal.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }

	/**
	 * @see net.refractions.udig.project.internal.render.CompositeRenderContext#getMapLayers()
	 */
	public List<Layer> getLayersInternal() {
		List<Layer> list = new ArrayList<Layer>();
		for (RenderContext context : getContextsInternal())
			list.add(context.getLayerInternal());
		return list;
	}

	/**
	 * @see net.refractions.udig.project.render.ICompositeRenderContext#getLayers()
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List getLayers() {
		return getLayersInternal();
	}

	/**
	 * @see net.refractions.udig.project.render.ICompositeRenderContext#getContexts()
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List getContexts() {
		return Collections.unmodifiableList(getContextsInternal());
	}

	@Override
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		for (RenderContext context : getContextsInternal()) {
			if (context==this )
				buffer.append( "\n -" + super.toString() ); //$NON-NLS-1$
			else
				buffer.append("\n -" + context.toString()); //$NON-NLS-1$
		}
		return buffer.length()==0?super.toString():buffer.toString();
	}

	@Override
	public void setStatus(int status) {
		if (getContexts().size() == 0) {
			super.setStatus(status);
			return;
		} 

		{
			for (RenderContext context : getContextsInternal()) {
				if( context!=this)
					context.setStatus(status);
				else
					super.setStatus(status);
			}
		}
	}

	@Override
	public void setStatusMessage(String message) {
		if (getContexts().size() == 0) {
			super.setStatusMessage(message);
			return;
		} 
		{
			for (RenderContext context : getContextsInternal()) {
				if( context!=this)
					context.setStatusMessage(message);
				else
					super.setStatusMessage(message);
			}
		}

	}

	@Override
	public void dispose() {
		super.dispose();
		for (RenderContext context : getContextsInternal()) {
			if (context!=this)
				((RenderContextImpl)context).dispose();
		}
	}
	
} // CompositeRenderContextImpl
