/**
 * <copyright></copyright> $Id: RenderManagerImpl.java 17136 2005-12-02 22:06:38Z jeichar $
 */
package net.refractions.udig.project.internal.render.impl;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import net.refractions.udig.project.ILayer;
import net.refractions.udig.project.IMap;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.ProjectPlugin;
import net.refractions.udig.project.internal.render.ExecutorVisitor;
import net.refractions.udig.project.internal.render.RenderContext;
import net.refractions.udig.project.internal.render.RenderExecutor;
import net.refractions.udig.project.internal.render.RenderFactory;
import net.refractions.udig.project.internal.render.RenderManager;
import net.refractions.udig.project.internal.render.RenderPackage;
import net.refractions.udig.project.internal.render.Renderer;
import net.refractions.udig.project.internal.render.RendererCreator;
import net.refractions.udig.project.internal.render.SelectionLayer;
import net.refractions.udig.project.internal.render.ViewportModel;
import net.refractions.udig.project.render.IRenderer;
import net.refractions.udig.project.render.displayAdapter.IMapDisplay;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.notify.impl.NotificationChainImpl;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import com.vividsolutions.jts.geom.Envelope;

/**
 * TODO Purpose of net.refractions.udig.project.internal.render.impl <p> </p>
 * @author   Jesse
 * @since   1.0.0
 * @generated
 */
public class RenderManagerImpl extends EObjectImpl implements RenderManager {
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

    /**
     * The cached value of the '{@link #getRenderExecutor() <em>Render Executor</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getRenderExecutor()
     * @generated
     * @ordered
     */
	protected RenderExecutor renderExecutor = null;

    /**
     * The cached value of the '{@link #getRendererCreator() <em>Renderer Creator</em>}' containment reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getRendererCreator()
     * @generated
     * @ordered
     */
	protected RendererCreator rendererCreator = null;

    /**
     * The default value of the '{@link #getMapDisplay() <em>Map Display</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getMapDisplay()
     * @generated
     * @ordered
     */
	protected static final IMapDisplay MAP_DISPLAY_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getMapDisplay() <em>Map Display</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getMapDisplay()
     * @generated
     * @ordered
     */
	protected IMapDisplay mapDisplay = MAP_DISPLAY_EDEFAULT;

    /**
     * The cached value of the '{@link #getMapInternal() <em>Map Internal</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getMapInternal()
     * @generated
     * @ordered
     */
    protected Map mapInternal = null;

    /**
     * The cached value of the '{@link #getViewportModelInternal() <em>Viewport Model Internal</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getViewportModelInternal()
     * @generated
     * @ordered
     */
    protected ViewportModel viewportModelInternal = null;
    
    /**
     * Indicate if the RenderManager has been disposed.
     */
    protected volatile boolean disposed=false;
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	protected RenderManagerImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	protected EClass eStaticClass() {
        return RenderPackage.eINSTANCE.getRenderManager();
    }

	/**
	 * Prints the current renderstack.
	 */
	public void printRenderStack(){
        checkState();
		if( getRenderExecutor()!=null){
			final StringBuffer msg=new StringBuffer();
			getRenderExecutor().visit(new ExecutorVisitor(){
				int i=0;
				public void visit(RenderExecutor executor) {
					i++;
					String layername=executor.getContext().getLayer().getID().toString();
					if( executor.getContext().getLayer() instanceof SelectionLayer ){
						layername+="<Selection>"; //$NON-NLS-1$
					}
					msg.append("\n"+i+" - "+layername); //$NON-NLS-1$ //$NON-NLS-2$
					
				}

				public void visit(RendererExecutorMultiLayer executor) {
					for( ILayer layer:executor.getContext().getLayers() ){
						i++;
						String layername=layer.getID().toString();
						if( layer instanceof SelectionLayer ){
							layername+="<Selection>"; //$NON-NLS-1$
						}
						msg.append("\n"+i+" - "+layername); //$NON-NLS-1$ //$NON-NLS-2$
					}
				}

				public void visit(CompositeRendererExecutorImpl executor) {
					for( RenderExecutor renderer:executor.getRenderer().getRenderExecutors()){
						renderer.visit(this);
					}
				}
			});
            ProjectPlugin.log( msg.toString(), null );
		}
	}
	
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public Map getMapInternal() {
        checkState();
        if (mapInternal != null && mapInternal.eIsProxy()) {
            Map oldMapInternal = mapInternal;
            mapInternal = (Map)eResolveProxy((InternalEObject)mapInternal);
            if (mapInternal != oldMapInternal) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, RenderPackage.RENDER_MANAGER__MAP_INTERNAL, oldMapInternal, mapInternal));
            }
        }
        return mapInternal;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Map basicGetMapInternal() {
        return mapInternal;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetMapInternal(Map newMapInternal, NotificationChain msgs) {
        Map oldMapInternal = mapInternal;
        mapInternal = newMapInternal;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RenderPackage.RENDER_MANAGER__MAP_INTERNAL, oldMapInternal, newMapInternal);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setMapInternalGen(Map newMapInternal) {
        checkState();
        if (newMapInternal != mapInternal) {
            NotificationChain msgs = null;
            if (mapInternal != null)
                msgs = ((InternalEObject)mapInternal).eInverseRemove(this, ProjectPackage.MAP__RENDER_MANAGER_INTERNAL, Map.class, msgs);
            if (newMapInternal != null)
                msgs = ((InternalEObject)newMapInternal).eInverseAdd(this, ProjectPackage.MAP__RENDER_MANAGER_INTERNAL, Map.class, msgs);
            msgs = basicSetMapInternal(newMapInternal, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, RenderPackage.RENDER_MANAGER__MAP_INTERNAL, newMapInternal, newMapInternal));
    }

	boolean viewer = false;

	/**
     * @return   Returns the viewer.
     * @uml.property   name="viewer"
     */
	public boolean isViewer() {
        checkState();
		return viewer;
	}

	/**
     * @param viewer   The viewer to set.
     * @uml.property   name="viewer"
     */
	public void setViewer(boolean viewer) {
        checkState();
		this.viewer = viewer;
	}

	/**
     * @see net.refractions.udig.project.internal.render.RenderManager#setMap(net.refractions.udig.project.Map)
     * @uml.property   name="mapInternal"
     */
	public void setMapInternal(Map newMap) {
        checkState();
		if (isViewer()) {
			basicSetMapInternal(newMap, new NotificationChainImpl());
		} else
			setMapInternalGen(newMap);
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public IMapDisplay getMapDisplay() {
        checkState();
        return mapDisplay;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public void setMapDisplay(IMapDisplay newMapDisplay) {
        IMapDisplay oldMapDisplay = mapDisplay;
        mapDisplay = newMapDisplay;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, RenderPackage.RENDER_MANAGER__MAP_DISPLAY, oldMapDisplay, mapDisplay));
    }

	/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated  NOT
     */
	public RendererCreator getRendererCreator() {
        checkState();
		if( rendererCreator==null ){
			setRendererCreator(RenderFactory.eINSTANCE.createRendererCreator());
			RenderContext context=RenderFactory.eINSTANCE.createRenderContext();
			context.setMapInternal(getMapInternal());
			context.setRenderManagerInternal(this);
			rendererCreator.setContext(context);
		}
	    return rendererCreator;
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetRendererCreator(RendererCreator newRendererCreator, NotificationChain msgs) {
        RendererCreator oldRendererCreator = rendererCreator;
        rendererCreator = newRendererCreator;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RenderPackage.RENDER_MANAGER__RENDERER_CREATOR, oldRendererCreator, newRendererCreator);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public void setRendererCreator(RendererCreator newRendererCreator) {
        if (newRendererCreator != rendererCreator) {
            NotificationChain msgs = null;
            if (rendererCreator != null)
                msgs = ((InternalEObject)rendererCreator).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RenderPackage.RENDER_MANAGER__RENDERER_CREATOR, null, msgs);
            if (newRendererCreator != null)
                msgs = ((InternalEObject)newRendererCreator).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RenderPackage.RENDER_MANAGER__RENDERER_CREATOR, null, msgs);
            msgs = basicSetRendererCreator(newRendererCreator, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, RenderPackage.RENDER_MANAGER__RENDERER_CREATOR, newRendererCreator, newRendererCreator));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public ViewportModel getViewportModelInternal() {
        checkState();
        return viewportModelInternal;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetViewportModelInternal(ViewportModel newViewportModelInternal, NotificationChain msgs) {
        ViewportModel oldViewportModelInternal = viewportModelInternal;
        viewportModelInternal = newViewportModelInternal;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL, oldViewportModelInternal, newViewportModelInternal);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void setViewportModelInternal(ViewportModel newViewportModelInternal) {
        if (newViewportModelInternal != viewportModelInternal) {
            NotificationChain msgs = null;
            if (viewportModelInternal != null)
                msgs = ((InternalEObject)viewportModelInternal).eInverseRemove(this, RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL, ViewportModel.class, msgs);
            if (newViewportModelInternal != null)
                msgs = ((InternalEObject)newViewportModelInternal).eInverseAdd(this, RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL, ViewportModel.class, msgs);
            msgs = basicSetViewportModelInternal(newViewportModelInternal, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL, newViewportModelInternal, newViewportModelInternal));
    }

	/**
	 * @throws IOException
	 * @see net.refractions.udig.project.internal.render.RenderManager#getInfo(java.awt.Point)
	 *
	public List getInfo(Point screenLocation) throws IOException {
		return getRenderExecutor().getInfo(screenLocation);
	}*/

    /**
     * @throws IOException
     * @see net.refractions.udig.project.internal.render.RenderManager#getInfo(java.awt.Point)   public List getInfo(Point screenLocation) throws IOException {  return getRenderExecutor().getInfo(screenLocation);  }
     * @uml.property   name="renderExecutor"
     * @generated
     */
	public RenderExecutor getRenderExecutor() {
        checkState();
		if( renderExecutor==null )
			setRenderExecutor(RenderFactory.eINSTANCE.createRenderExecutor());
		
        return renderExecutor;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public void setRenderExecutor(RenderExecutor newRenderExecutor) {
        RenderExecutor oldRenderExecutor = renderExecutor;
        renderExecutor = newRenderExecutor;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, RenderPackage.RENDER_MANAGER__RENDER_EXECUTOR, oldRenderExecutor, renderExecutor));
    }

    /**
     * If subclasses override this method make sure that super.dispose() is called <b>AT THE END<b> of
     * the overridding method.  
     * 
     * @generated NOT
     */
	public void dispose() {
        checkState();
		if (renderExecutor != null){
			((RenderContextImpl) renderExecutor.getContext()).dispose();
			getRenderExecutor().dispose();
		}

		
		renderExecutor = null;

		
        getMapInternal().setRenderManagerInternal(null);
        
        disposed=true;
        
//        Runtime.getRuntime().gc();
    }
    
    public void checkState() throws IllegalStateException{
        if( disposed )
            throw new IllegalStateException("RenderManager is disposed");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
                case RenderPackage.RENDER_MANAGER__MAP_INTERNAL:
                    if (mapInternal != null)
                        msgs = ((InternalEObject)mapInternal).eInverseRemove(this, ProjectPackage.MAP__RENDER_MANAGER_INTERNAL, Map.class, msgs);
                    return basicSetMapInternal((Map)otherEnd, msgs);
                case RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL:
                    if (viewportModelInternal != null)
                        msgs = ((InternalEObject)viewportModelInternal).eInverseRemove(this, RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL, ViewportModel.class, msgs);
                    return basicSetViewportModelInternal((ViewportModel)otherEnd, msgs);
                default:
                    return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
                case RenderPackage.RENDER_MANAGER__RENDERER_CREATOR:
                    return basicSetRendererCreator(null, msgs);
                case RenderPackage.RENDER_MANAGER__MAP_INTERNAL:
                    return basicSetMapInternal(null, msgs);
                case RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL:
                    return basicSetViewportModelInternal(null, msgs);
                default:
                    return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case RenderPackage.RENDER_MANAGER__RENDER_EXECUTOR:
                return getRenderExecutor();
            case RenderPackage.RENDER_MANAGER__RENDERER_CREATOR:
                return getRendererCreator();
            case RenderPackage.RENDER_MANAGER__MAP_DISPLAY:
                return getMapDisplay();
            case RenderPackage.RENDER_MANAGER__MAP_INTERNAL:
                if (resolve) return getMapInternal();
                return basicGetMapInternal();
            case RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL:
                return getViewportModelInternal();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case RenderPackage.RENDER_MANAGER__RENDER_EXECUTOR:
                setRenderExecutor((RenderExecutor)newValue);
                return;
            case RenderPackage.RENDER_MANAGER__RENDERER_CREATOR:
                setRendererCreator((RendererCreator)newValue);
                return;
            case RenderPackage.RENDER_MANAGER__MAP_DISPLAY:
                setMapDisplay((IMapDisplay)newValue);
                return;
            case RenderPackage.RENDER_MANAGER__MAP_INTERNAL:
                setMapInternal((Map)newValue);
                return;
            case RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL:
                setViewportModelInternal((ViewportModel)newValue);
                return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case RenderPackage.RENDER_MANAGER__RENDER_EXECUTOR:
                setRenderExecutor((RenderExecutor)null);
                return;
            case RenderPackage.RENDER_MANAGER__RENDERER_CREATOR:
                setRendererCreator((RendererCreator)null);
                return;
            case RenderPackage.RENDER_MANAGER__MAP_DISPLAY:
                setMapDisplay(MAP_DISPLAY_EDEFAULT);
                return;
            case RenderPackage.RENDER_MANAGER__MAP_INTERNAL:
                setMapInternal((Map)null);
                return;
            case RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL:
                setViewportModelInternal((ViewportModel)null);
                return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case RenderPackage.RENDER_MANAGER__RENDER_EXECUTOR:
                return renderExecutor != null;
            case RenderPackage.RENDER_MANAGER__RENDERER_CREATOR:
                return rendererCreator != null;
            case RenderPackage.RENDER_MANAGER__MAP_DISPLAY:
                return MAP_DISPLAY_EDEFAULT == null ? mapDisplay != null : !MAP_DISPLAY_EDEFAULT.equals(mapDisplay);
            case RenderPackage.RENDER_MANAGER__MAP_INTERNAL:
                return mapInternal != null;
            case RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL:
                return viewportModelInternal != null;
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public String toString() {
        checkState();
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (mapDisplay: "); //$NON-NLS-1$
        result.append(mapDisplay);
        result.append(')');
        return result.toString();
    }

	/**
	 * @see net.refractions.udig.project.internal.render.RenderManager#refresh(net.refractions.udig.project.Layer,
	 *      com.vividsolutions.jts.geom.Envelope)
	 */
	public void refresh(ILayer layer, Envelope bounds) {
		throw new UnsupportedOperationException();

	}

	/**
	 * @see net.refractions.udig.project.internal.render.RenderManager#refresh(com.vividsolutions.jts.geom.Envelope)
	 */
	public void refresh(Envelope bounds) {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see net.refractions.udig.project.internal.render.RenderManager#refreshSelection(com.vividsolutions.jts.geom.Envelope)
	 */
	public void refreshSelection(ILayer layer, Envelope bounds) {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see net.refractions.udig.project.render.IRenderManager#getMap()
	 */
	public IMap getMap() {
        checkState();
		return getMapInternal();
	}

	/**
	 * @see net.refractions.udig.project.render.IRenderManager#getRenderers()
	 */
	public List<IRenderer> getRenderers() {
        checkState();
		final List<IRenderer> renderers=new ArrayList<IRenderer>();
		getRenderExecutor().visit(new ExecutorVisitor(){

			public void visit(RenderExecutor executor) {
				renderers.add(executor.getRenderer());
			}

			public void visit(RendererExecutorMultiLayer executor) {
				renderers.add(executor.getRenderer());
			}

			public void visit(CompositeRendererExecutorImpl executor) {
				for( RenderExecutor currentExecutor: executor.getRenderer().getRenderExecutors() )
					currentExecutor.visit(this);
			}
			
		});
		
		Collections.sort(renderers, new Comparator<IRenderer>(){

			public int compare(IRenderer arg0, IRenderer arg1) {
				return arg0.getContext().getLayer().compareTo(arg1.getContext().getLayer());
			}
			
		});
		return renderers;
	}

    public void stopRendering() {
        checkState();
        if( getRenderExecutor()!=null )
            getRenderExecutor().stopRendering();
    }

    public boolean isDisposed() {
        return disposed;
    }

} // RenderManagerImpl
