package net.refractions.udig.project.ui.internal;

/**
 * Constants for use with eclipse tracing api.
 * Rember only engage tracing if ProjectUIPlugin.getDefault().isDebugging().
 * <p>
 * Sample use:<pre><code>
 * static import net.refractions.udig.project.ui.internal.RENDERING;
 * 
 * if( ProjectUIPlugin.isDebugging( RENDERING ) ){
 *      System.out.println( "your message here" );
 * }
 * </code></pre>
 * </p>
 */
public interface Trace {
    /** You may set this to "true" in your .options file */
    public static final String RENDER =
        "net.refractions.udig.project.ui/debug/render/trace"; //$NON-NLS-1$
}
