/* uDig - User Friendly Desktop Internet GIS client
 * http://udig.refractions.net
 * (C) 2004, Refractions Research Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */
package net.refractions.udig.project.ui.internal;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryContentProvider;
import org.eclipse.ui.PlatformUI;

/**
 * This AdapterFactory guarantees that it will not update its listeners if the workbench has been
 * disposed.
 * 
 * @author jgarnett
 * @since 1.0.0
 */
public class UDIGAdapterFactoryContentProvider extends AdapterFactoryContentProvider {
    public UDIGAdapterFactoryContentProvider( AdapterFactory adapterFactory ) {
        super(adapterFactory);
    }

    @Override
    public void notifyChanged( Notification notification ) {
        if( !PlatformUI.getWorkbench().isClosing() )
            super.notifyChanged(notification);
    }
}
