package net.refractions.udig.project.ui.internal.actions;

import java.util.List;

import net.refractions.udig.catalog.IResolve;
import net.refractions.udig.catalog.internal.ui.ImageConstants;
import net.refractions.udig.catalog.internal.ui.Images;
import net.refractions.udig.catalog.ui.DataSourceSelectionPage;
import net.refractions.udig.catalog.ui.IDataWizard;
import net.refractions.udig.project.ui.internal.MapFactory;
import net.refractions.udig.project.ui.internal.Policy;
import net.refractions.udig.project.ui.internal.ResourceSelectionPage;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.ui.IWorkbench;

public class AddLayersWizard extends IDataWizard {
	
    @Override
    public void init( IWorkbench workbench, IStructuredSelection selection ) {
        super.init(workbench, selection);
        
        setWindowTitle( Policy.bind( "AddLayersWizard.title" ) ); 
        setDefaultPageImageDescriptor( Images.getDescriptor( ImageConstants.DATA_WIZBAN ));
    }
	@Override
	public boolean performFinish() {
		if( getContainer().getCurrentPage() instanceof ResourceSelectionPage){
			ResourceSelectionPage resourcePage 
				= (ResourceSelectionPage)getContainer().getCurrentPage();
			List<IResolve> resolves = resourcePage.getResources();
			
			if (!resourcePage.getCheckedElements().isEmpty()) {
				//check to see if we have selected resources yet
	            MapFactory.instance().process(null,resourcePage.getCheckedElements(), false);
	            return true;	
			}
			
			List<IResolve> resources = resourcePage.getResources();
			if (resources != null) {
				  MapFactory.instance().process(null, resources, false);
				  return true;
			}
	    }
				
		return false;
	}
	
	@Override
	protected WizardPage[] getPrimaryPages() {
		ResourceSelectionPage page = new ResourceSelectionPage(
			Policy.bind("AddLayersWizard.layerSelection") //$NON-NLS-1$
		); 
		
		return new WizardPage[]{new DataSourceSelectionPage(), page};
	}
	
}