package net.refractions.udig.project.ui.internal.actions;

import java.util.ArrayList;

import net.refractions.udig.catalog.IGeoResource;
import net.refractions.udig.mapgraphic.MapGraphic;
import net.refractions.udig.project.ui.internal.MapFactory;
import net.refractions.udig.ui.IDropAction;

import org.eclipse.core.runtime.IProgressMonitor;

public class MapGraphicDropAction extends IDropAction {

    @Override
    public boolean accept( Object source, Object destination ) {
        //ensure that the resource is a map graphics
        if (source instanceof IGeoResource) {
            IGeoResource resource = (IGeoResource)source;
            return resource.canResolve(MapGraphic.class);
        }
        
        return false;
    }

    @Override
    public void perform( 
        Object source, Object destination, IProgressMonitor monitor 
    ) {
        ArrayList<Object> l = new ArrayList<Object>();
        l.add(source);
        
        MapFactory.instance().process(null, l, false);
    }
}

