/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.ui.internal.properties;

import org.eclipse.jface.viewers.ICellEditorValidator;
import org.geotools.feature.AttributeType;

/**
 * Validates that an input is a legal input
 * 
 * @author jeichar
 * @since 0.3
 */
public class AttributeValidator implements ICellEditorValidator {
    private AttributeType type;
    /**
     * Creates a new instance of AttributeValidator
     * @param type The AttributeType that the new instance will validate
     */
    public AttributeValidator(AttributeType type) {
        this.type=type;
    }
    /**
     * @see org.eclipse.jface.viewers.ICellEditorValidator#isValid(java.lang.Object)
     */
    public String isValid(Object value) {
        try{
           type.validate(value);
           return null;
        }catch (Exception e) {
            return e.getLocalizedMessage();
        }
    }
}
