/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.ui.internal.properties;

import java.util.ArrayList;
import java.util.List;

import net.refractions.udig.project.ui.internal.Policy;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.geotools.data.FeatureSource;
import org.geotools.feature.AttributeType;
import org.geotools.feature.FeatureType;

/**
 * TODO provide type description
 * 
 * @author jeichar
 * @since TODO provide version
 */
public class ScemaDescriptor extends PropertyDescriptor implements IPropertySource{

    private IPropertyDescriptor[] descriptors;
    private FeatureType type;

    /**
     * Creates a new instance of FeatureSourceDescriptor
     * @param id
     * @param name
     * @param source
     */
    public ScemaDescriptor(Object id, String name, FeatureSource source) {
        super(id, name);
        type=source.getSchema();
    }

    /**
     * @see org.eclipse.ui.views.properties.PropertyDescriptor#createPropertyEditor(org.eclipse.swt.widgets.Composite)
     */
    public CellEditor createPropertyEditor(Composite parent) {
        return new SchemaEditor(parent, type);
    }
    
    /**
     * @see org.eclipse.ui.views.properties.IPropertySource#getEditableValue()
     */
    public Object getEditableValue() {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyDescriptors()
     */
    public IPropertyDescriptor[] getPropertyDescriptors() {
        if( descriptors==null){
            List desc=new ArrayList();
            AttributeType[] attrs=type.getAttributeTypes();
            PropertyDescriptor d;
            for (int i = 0; i < attrs.length; i++) {
                String name = attrs[i].getName().toLowerCase();
                name = name.substring(0, 1).toUpperCase() + name.substring(1);
                d=new PropertyDescriptor(new Integer(i), name);
                if( attrs[i].isGeometry())
                    d.setCategory(Policy.bind("ScemaDescriptor.geometry")); //$NON-NLS-1$
                else
                    d.setCategory(Policy.bind("ScemaDescriptor.attributeTypes")); //$NON-NLS-1$
                desc.add(d);
            }
            descriptors=new IPropertyDescriptor[desc.size()];
            desc.toArray(descriptors);
        }
        return descriptors;
    }

    /**
     * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyValue(java.lang.Object)
     */
    public Object getPropertyValue(Object id) {
        int i=((Integer)id).intValue();
        String name=type.getAttributeType(i).getType().getName();
        return name.substring(name.lastIndexOf('.')+1);
    }

    /**
     * @see org.eclipse.ui.views.properties.IPropertySource#isPropertySet(java.lang.Object)
     */
    public boolean isPropertySet(Object id) {
        // TODO Auto-generated method stub
        return false;
    }

    /**
     * @see org.eclipse.ui.views.properties.IPropertySource#resetPropertyValue(java.lang.Object)
     */
    public void resetPropertyValue(Object id) {
        // TODO Auto-generated method stub
        
    }

    /**
     * @see org.eclipse.ui.views.properties.IPropertySource#setPropertyValue(java.lang.Object, java.lang.Object)
     */
    public void setPropertyValue(Object id, Object value) {
        // TODO Auto-generated method stub
        
    }
}
