/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.ui.internal.tool.display;

import java.util.List;

import org.eclipse.core.commands.IHandler;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;

/**
 * All Fire and forget actions are in this category.
 * 
 * @author jeichar
 * @since 0.9.0
 */
public class ActionToolCategory extends ToolCategory {

	private ActionCurrentToolItem contribution;

	/**
	 * Construct <code>ActionCategory</code>.
	 *
	 * @param element
	 * @param manager
	 */
	protected ActionToolCategory(IConfigurationElement element, ToolManager manager) {
		super(element, manager);
	}
    /**
	 * Construct <code>ActionToolCategory2</code>.
	 *
	 * @param manager
	 */
	public ActionToolCategory(ToolManager manager) {
		super(manager);
	}

	protected void contribute(IToolBarManager manager) {
        for( ModalItem item: items ){
            manager.add( ((ToolProxy)item).getAction());
        }
	}


	protected class ActionCurrentToolItem extends ToolbarCurrentItem {


		/**
		 * @see net.refractions.udig.project.ui.internal.tool.display.CurrentContributionItem#setSelection(boolean)
		 */
		public void setSelection(boolean checked, ModalItem proxy) {
			//do nothing.
		}

		/**
		 * @see net.refractions.udig.project.ui.internal.tool.display.CurrentContributionItem#isChecked()
		 */
		protected boolean isChecked() {
			return false;
		}

		/**
		 * @see net.refractions.udig.project.ui.internal.tool.display.ToolbarCurrentItem#isDefaultItem()
		 */
		protected boolean isDefaultItem() {
			return false;
		}

		/**
		 * @see net.refractions.udig.project.ui.internal.tool.display.ToolbarCurrentItem#createToolItem(org.eclipse.swt.widgets.ToolBar, int)
		 */
		protected ToolItem createToolItem(ToolBar parent, int index) {
			return toolItem = new ToolItem(parent, SWT.PUSH, index);
		}

		/**
		 * @see net.refractions.udig.project.ui.internal.tool.display.ToolbarCurrentItem#getTools()
		 */
		protected List<ModalItem> getTools() {
			return items;
		}

	}

    /**
     * @see net.refractions.udig.project.ui.internal.tool.display.ToolCategory#getHandlerSubmission(java.lang.String)
     */
    protected IHandler getHandler() {
        return null;
    }

}
