/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.ui.internal.tool.display;

import java.util.List;

import org.eclipse.core.commands.IHandler;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;


/**
 * A category object that contributes to a toolbar.
 * 
 * @author jeichar
 * @since 0.9.0
 */
public class ModalToolCategory extends ToolCategory {


	private ToolbarCurrentToolItem contribution;
    private IHandler handler;

	/**
	 * Construct <code>ToolbarToolCategory</code>.
	 * 
	 * @param element
	 * @param manager
	 */
	protected ModalToolCategory(IConfigurationElement element, ToolManager manager) {
		super(element, manager);
	}


    /**
	 * Construct <code>ModalToolCategory</code>.
	 *
	 * @param manager
	 */
	public ModalToolCategory(ToolManager manager) {
		super(manager);
	}

	/**
	 * @see net.refractions.udig.project.ui.internal.tool.display.ToolCategory#getHandlerSubmission(java.lang.String)
	 */
	protected IHandler getHandler() {
        if (handler == null) {
            handler = new ToolCommandHandler(this);
        }

        return handler;
	}
    
	public ToolbarCurrentToolItem getContribution() {
		return contribution;
	}

    protected void contribute(IToolBarManager manager) {
        contribution = new ToolbarCurrentToolItem();
        manager.add(contribution);
//    	manager.add(new ToolbarDropDownItem(this, contribution));
        for(ModalItem proxy:this){
            proxy.getContributions().add(contribution);
        }
    }

	/**
	 * @author jones
	 *
	 */
	protected class ToolbarCurrentToolItem extends ToolbarCurrentItem {
           
			/**
			 * @see net.refractions.udig.project.ui.internal.tool.display.ToolbarCurrentItem#createToolItem(org.eclipse.swt.widgets.ToolBar, int)
			 */
			protected ToolItem createToolItem(final ToolBar parent, int index) {
				final ToolItem item=new ToolItem(parent, SWT.DROP_DOWN, index);
				return item;
			}
			
			/**
			 * @see net.refractions.udig.project.ui.internal.tool.display.ToolbarCurrentItem#getTools()
			 */
			protected List<ModalItem> getTools() {
				return items;
			}
			
			/**
			 * @see net.refractions.udig.project.ui.internal.tool.display.ToolbarCurrentItem#isDefaultItem()
			 */
			protected boolean isDefaultItem() {
				return getTools().contains(ToolProxy.defaultItem);
			}
	}


}
