/**
 * <copyright>
 * </copyright>
 *
 * $Id: ToolFactoryImpl.java 15092 2005-08-04 00:24:24Z jgarnett $
 */
package net.refractions.udig.project.ui.internal.tool.impl;

import java.awt.Point;
import java.util.List;

import net.refractions.udig.project.command.EditCommand;
import net.refractions.udig.project.command.EditCommandFactory;
import net.refractions.udig.project.command.EditManagerControlCommand;
import net.refractions.udig.project.command.MapCommand;
import net.refractions.udig.project.command.NavCommand;
import net.refractions.udig.project.command.NavigationCommandFactory;
import net.refractions.udig.project.command.SelectionCommandFactory;
import net.refractions.udig.project.ui.commands.DrawCommandFactory;
import net.refractions.udig.project.ui.internal.tool.ToolContext;
import net.refractions.udig.project.ui.internal.tool.ToolFactory;
import net.refractions.udig.project.ui.internal.tool.ToolPackage;
import net.refractions.udig.project.ui.render.displayAdapter.ViewportPane;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.EFactoryImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ToolFactoryImpl extends EFactoryImpl implements ToolFactory {
	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public ToolFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case ToolPackage.TOOL_CONTEXT: return createToolContext();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case ToolPackage.LIST:
				return createListFromString(eDataType, initialValue);
			case ToolPackage.NAVIGATION_COMMAND_FACTORY:
				return createNavigationCommandFactoryFromString(eDataType, initialValue);
			case ToolPackage.COMMAND:
				return createCommandFromString(eDataType, initialValue);
			case ToolPackage.EDIT_MANAGER_CONTROL_COMMAND:
				return createEditManagerControlCommandFromString(eDataType, initialValue);
			case ToolPackage.POINT:
				return createPointFromString(eDataType, initialValue);
			case ToolPackage.SELECTION_COMMAND_FACTORY:
				return createSelectionCommandFactoryFromString(eDataType, initialValue);
			case ToolPackage.NAV_COMMAND:
				return createNavCommandFromString(eDataType, initialValue);
			case ToolPackage.EDIT_COMMAND:
				return createEditCommandFromString(eDataType, initialValue);
			case ToolPackage.DRAW_COMMAND_FACTORY:
				return createDrawCommandFactoryFromString(eDataType, initialValue);
			case ToolPackage.VIEWPORT_PANE:
				return createViewportPaneFromString(eDataType, initialValue);
			case ToolPackage.EDIT_COMMAND_FACTORY:
				return createEditCommandFactoryFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public ToolContext createToolContext() {
		ToolContextImpl toolContext = new ToolContextImpl();
		return toolContext;
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EditCommand createEditCommandFromString(EDataType eDataType, String initialValue) {
		return (EditCommand)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertEditCommandToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NavigationCommandFactory createNavigationCommandFactoryFromString(EDataType eDataType, String initialValue) {
		return (NavigationCommandFactory)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertNavigationCommandFactoryToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NavCommand createNavCommandFromString(EDataType eDataType, String initialValue) {
		return (NavCommand)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertNavCommandToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public SelectionCommandFactory createSelectionCommandFactoryFromString(EDataType eDataType, String initialValue) {
		return (SelectionCommandFactory)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertSelectionCommandFactoryToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case ToolPackage.LIST:
				return convertListToString(eDataType, instanceValue);
			case ToolPackage.NAVIGATION_COMMAND_FACTORY:
				return convertNavigationCommandFactoryToString(eDataType, instanceValue);
			case ToolPackage.COMMAND:
				return convertCommandToString(eDataType, instanceValue);
			case ToolPackage.EDIT_MANAGER_CONTROL_COMMAND:
				return convertEditManagerControlCommandToString(eDataType, instanceValue);
			case ToolPackage.POINT:
				return convertPointToString(eDataType, instanceValue);
			case ToolPackage.SELECTION_COMMAND_FACTORY:
				return convertSelectionCommandFactoryToString(eDataType, instanceValue);
			case ToolPackage.NAV_COMMAND:
				return convertNavCommandToString(eDataType, instanceValue);
			case ToolPackage.EDIT_COMMAND:
				return convertEditCommandToString(eDataType, instanceValue);
			case ToolPackage.DRAW_COMMAND_FACTORY:
				return convertDrawCommandFactoryToString(eDataType, instanceValue);
			case ToolPackage.VIEWPORT_PANE:
				return convertViewportPaneToString(eDataType, instanceValue);
			case ToolPackage.EDIT_COMMAND_FACTORY:
				return convertEditCommandFactoryToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DrawCommandFactory createDrawCommandFactoryFromString(EDataType eDataType, String initialValue) {
		return (DrawCommandFactory)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertDrawCommandFactoryToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public MapCommand createCommandFromString(EDataType eDataType, String initialValue) {
		return (MapCommand)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertCommandToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EditCommandFactory createEditCommandFactoryFromString(EDataType eDataType, String initialValue) {
		return (EditCommandFactory)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertEditCommandFactoryToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public ViewportPane createViewportPaneFromString(EDataType eDataType, String initialValue) {
		return (ViewportPane)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertViewportPaneToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Point createPointFromString(EDataType eDataType, String initialValue) {
		return (Point)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertPointToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public List createListFromString(EDataType eDataType, String initialValue) {
		return (List)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertListToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EditManagerControlCommand createEditManagerControlCommandFromString(EDataType eDataType, String initialValue) {
		return (EditManagerControlCommand)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String convertEditManagerControlCommandToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public ToolPackage getToolPackage() {
		return (ToolPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
    public static ToolPackage getPackage() {
		return ToolPackage.eINSTANCE;
	}

} //ToolFactoryImpl
