/**
 * <copyright>
 * </copyright>
 *
 * $Id: ToolAdapterFactory.java 15092 2005-08-04 00:24:24Z jgarnett $
 */
package net.refractions.udig.project.ui.internal.tool.util;

import net.refractions.udig.project.IAbstractContext;
import net.refractions.udig.project.internal.AbstractContext;
import net.refractions.udig.project.ui.internal.tool.ToolContext;
import net.refractions.udig.project.ui.internal.tool.ToolPackage;
import net.refractions.udig.project.ui.tool.IToolContext;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see net.refractions.udig.project.ui.internal.tool.ToolPackage
 * @generated
 */
public class ToolAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected static ToolPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public ToolAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = ToolPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
     * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
     * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
    public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ToolSwitch modelSwitch =
		new ToolSwitch() {
			public Object caseIToolContext(IToolContext object) {
				return createIToolContextAdapter();
			}
			public Object caseToolContext(ToolContext object) {
				return createToolContextAdapter();
			}
			public Object caseCloneable(Cloneable object) {
				return createCloneableAdapter();
			}
			public Object caseIAbstractContext(IAbstractContext object) {
				return createIAbstractContextAdapter();
			}
			public Object caseAbstractContext(AbstractContext object) {
				return createAbstractContextAdapter();
			}
			public Object defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
    public Adapter createAdapter(Notifier target) {
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link net.refractions.udig.project.ui.internal.tool.ToolContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see net.refractions.udig.project.ui.internal.tool.ToolContext
	 * @generated
	 */
    public Adapter createToolContextAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link net.refractions.udig.project.ui.tool.IToolContext <em>ITool Context</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see net.refractions.udig.project.ui.tool.IToolContext
	 * @generated
	 */
    public Adapter createIToolContextAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link Cloneable <em>Cloneable</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see Cloneable
	 * @generated
	 */
    public Adapter createCloneableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link net.refractions.udig.project.IAbstractContext <em>IAbstract Context</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see net.refractions.udig.project.IAbstractContext
	 * @generated
	 */
    public Adapter createIAbstractContextAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link net.refractions.udig.project.internal.AbstractContext <em>Abstract Context</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see net.refractions.udig.project.internal.AbstractContext
	 * @generated
	 */
    public Adapter createAbstractContextAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
     * This default implementation returns null.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
    public Adapter createEObjectAdapter() {
		return null;
	}

} //ToolAdapterFactory
