/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.ui.tool;



/**
 * An abstract super class that modal tools can extend.
 * <p>
 * The editor will only maintain one modal tool in the "enabled" state
 * at one time.
 * </p>
 * @author jeichar
 * @since 0.3
 * @see AbstractTool
 * @see ModalTool
 */
public abstract class AbstractModalTool extends AbstractTool implements ModalTool{

    /**
     * Creates an new instance of AbstractModalTool
     * @see AbstractTool#AbstractTool(int)
     */
    public AbstractModalTool(int targets) {
        super(targets);
    }

    /**
     * @see net.refractions.udig.project.ui.tool.ModalTool#setActive(boolean)
     */
    public void setActive(boolean active) {
        if (!active) {
            deregisterMouseListeners();
        }else {
            registerMouseListeners();
        }
    }
    
    /**
     * @see net.refractions.udig.project.ui.tool.AbstractTool#setContext(net.refractions.udig.project.ui.tool.IToolContext)
     */
    public void setContext( IToolContext context ) {
        this.context=context;
    }

}
