/*
 * uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004,
 * Refractions Research Inc. This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; version 2.1 of the License. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 */
package net.refractions.udig.style.sld.internal;

import java.io.IOException;
import java.net.URL;

import net.refractions.udig.project.internal.Layer;

import org.eclipse.ui.part.IDropActionDelegate;
import org.geotools.styling.SLDParser;
import org.geotools.styling.StyleFactory;

/**
 * DnD of an SLD document onto a layer.
 * 
 * @author rgould
 * @since 0.6.0
 */
public class SLDDropAdapter implements IDropActionDelegate {

    /*
     * @see org.eclipse.ui.part.IDropActionDelegate#run(java.lang.Object, java.lang.Object)
     */
    public boolean run( Object source, Object target ) {
        // System.out.println(source+" ---- " + target);
        if (source instanceof URL) {
            URL url = (URL) source;
            if (url.toExternalForm().toUpperCase().endsWith(".SLD")) { //$NON-NLS-1$
                try {
                    StyleFactory factory = StyleFactory.createStyleFactory();
                    SLDParser styleReader = new SLDParser(factory, url);
                    // StyledLayerDescriptor sld = styleReader.parseSLD();

                    if (target instanceof Layer) {
                        Layer layer = (Layer) target;
                        // layer.setStyleBlackboard()
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return false;
    }

}
