package net.refractions.udig.ui;

import net.refractions.udig.internal.ui.UDIGDropHandler;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IProgressMonitor;


public abstract class IDropAction {
	
	public static final String XPID = "net.refractions.udig.ui.dropAction"; //$NON-NLS-1$
	
	/** the extension info **/
	IConfigurationElement element;
	
	/** drop adapter which processed the drop event **/
	UDIGDropHandler handler; 
	
	public void setElement(IConfigurationElement element) {
		this.element = element;
	}
	
	public IConfigurationElement getElement() {
		return element;
	}
	
	public String getName() {
		if (element == null)
			return ""; //$NON-NLS-1$
		return element.getAttribute("name"); //$NON-NLS-1$
	}
	
	public void setDropHandler(UDIGDropHandler handler) {
		this.handler = handler;
	}
	
	public UDIGDropHandler getDropHandler() {
		return handler;
	}
	
	public abstract boolean accept(Object source, Object destination);
	
	public abstract void perform(Object source, Object destination, IProgressMonitor monitor);
}